/*
gfx.cpp
Non-game specific graphics routines ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include <math.h>

#include "globals.h"




/*
// 8 bit version !!!

void drawwindow( int x, int y, int width, int height )
{
        byte *homeptr;
        byte *scrptr;
        byte *memptr;
        byte *picptr;

//		int screenoff;

        int index;


//        if( (fh = open("bitmaps\\window.pcx", O_RDONLY)) == ERROR) cleanup(NOFILE, "bitmaps\\window.pcx");
//        memptr = (byte *)unpackpcx(fh);
//        close(fh);

		memptr = loadandunpackbmp( "bitmaps\\window.bmp" );


//        y += 30;
//        x += 60;
//        screenoff = (y<<9) + (y<<8) + x;


		LOCKVS;

        homeptr = g_vsptr + VSOFFSET + times800(y) + x;

// Draw top ...

        scrptr = homeptr;
        picptr = memptr;

        for( index = 0; index < 6; index++ )
                {
                memcpy( scrptr, picptr, (width-6) );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop

// Draw left ...

        scrptr = homeptr;
        picptr = memptr;

        for( index = 0; index < height; index++ )
                {
                memcpy( scrptr, picptr, 6 );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop

// Draw right ...

        scrptr = homeptr + width-6;
        picptr = memptr + (600L-6L);

        for( index = 0; index < height-6; index++ )
                {
                memcpy( scrptr, picptr, 6 );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop

// Draw bottom ...

        scrptr = homeptr + times800(height-6) + 6;
        picptr = memptr + (600L*434L) + 6;

        for( index = 0; index < 6; index++ )
                {
                memcpy( scrptr, picptr, (width-12) );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop

// Draw bottom right ...

        scrptr = homeptr + times800(height-6) + (width-6);
        picptr = memptr + (600L*434L) + (600L-6L);

        for( index = 0; index < 6; index++ )
                {
                memcpy( scrptr, picptr, 6 );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop

// Draw inside ...

        scrptr = homeptr + (SCREENWIDTH*6L) + 6L;
        picptr = memptr + (600L*6L) + 6L;

        for( index = 0; index < height-12; index++ )
                {
                memcpy( scrptr, picptr, (width-12) );
                scrptr += SCREENWIDTH;
                picptr += 600L;
                } // end index loop


		UNLOCKVS;

        free( memptr );
        memoryused -= 600L * 440L * 2L;

} // end drawwindow
*/













// TODO -- Reassign text colors !!!!!

void mousemessage( char *textptr )
{
        int textx, texty;
        int length;
        int index;


        myfont = EURO;

        length = getlength( textptr );

        textx = cursorx - (length/2);
        texty = cursory - 8;

        if( textx < 16 ) textx = 16;
        if( textx > SCREENWIDTH-(length+12) ) textx = SCREENWIDTH-(length+12);
        if( texty < 16 ) texty = 16;
        if( texty > SCREENHEIGHT-28 ) texty = SCREENHEIGHT-28;

//        drawwindow( textx-14, texty-10, length+24, 28 );


	for( index = 0; index < 3; index++ )
        {
//        mytextcolor = TEXTYELLOW - 2;
//		SETTEXTCOLOR(24,24,4);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 2;
//		SETTEXTCOLOR(23,23,3);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 3;
//		SETTEXTCOLOR(22,22,2);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 4;
//		SETTEXTCOLOR(21,21,1);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 4;
//		SETTEXTCOLOR(20,20,0);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 4;
//		SETTEXTCOLOR(21,21,1);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 3;
//		SETTEXTCOLOR(22,22,2);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
//        mytextcolor = TEXTYELLOW - 2;
//		SETTEXTCOLOR(23,23,3);
        showtext( textptr, textx-2, texty-2 );
        displayscreen();
        waitfor( 3 );
        } // end index loop

} // end mousemessage




// 16 bit version of choosecolor ...
// This function is used mainly in editors to select a color from the palette ...

/*
word choosecolor( void )
{
	word r, g, b;
	word color;
	int x, y;

	word *tempscreenptr;

	MSG msg;

	int index;
	int lineindex, bitindex;
	int row, column;


	pushgamescreen( gamescreen );
	gamescreen = GS_SELECTCOLOR;

	LOCKVS;

	clearscreen();

	row = column = 0;

	for( r = 0; r < 32; r++ )
	{
		tempscreenptr = g_vsptr + VSOFFSET + (column * times768(64))+times768(128) + (row*64)+64;


		for( g = 0; g < 32; g++ )
		{
			for( b = 0; b < 32; b++ )
			{
				color = RGB16(r,g,b);

				*tempscreenptr = color;
				*(tempscreenptr+1) = color;
				*(tempscreenptr+VSCREENWIDTH) = color;
				*(tempscreenptr+VSCREENWIDTH+1) = color;

				tempscreenptr += 2;

			} // end b loop

			tempscreenptr += (VSCREENWIDTH*2)-64;

		} // end g loop

		row++;

		if( row == 8 ) { row = 0; column++; }

	} // end r loop


// Show selected color ...
	tempscreenptr = g_vsptr + VSOFFSET + times768(cursory) + cursorx;
	color = *tempscreenptr;

	tempscreenptr = g_vsptr + VSOFFSET + 256;
	for( lineindex = 0; lineindex < 64; lineindex++ )
	{
		for( bitindex = 0; bitindex < 128; bitindex++ )
		{
			*tempscreenptr++ = color;
		} // end bitindex loop

		tempscreenptr += VSCREENWIDTH-128;
	} // end lineindex loop


	UNLOCKVS;



// Main Confirm Loop ... let's see if this works ...
	g_response = 0xFF;

    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
					displayscreen();

// break out if g_response has changed in the message handler ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	LOCKVS;
// Get pixel under cursor ...
	tempscreenptr = g_vsptr + VSOFFSET + times768(cursory) + cursorx;

	color = *tempscreenptr;

	UNLOCKVS;


	gamescreen = popgamescreen();
	refreshscreen();

	return color;

} // end selectcolor

*/



// Slow right now ... quick hack ...
// 16 bit
/*
void clearscreen( void )
{
	word *tempscreenptr;
	int index;


	LOCKVS;

	tempscreenptr = g_vsptr + VSOFFSET;

	for( index = 0; index < SCREENHEIGHT; index++ )
	{
		ZeroMemory( tempscreenptr, SCREENWIDTH*2 );

		tempscreenptr += VSCREENWIDTH;
	} // end index loop

	UNLOCKVS;

} // end clearscreen
*/


/*
// 8 bit version of clearscreen
void clearscreen( void )
{
	byte *tempscreenptr;
	int index;


	LOCKVS;

	tempscreenptr = g_vsptr + VSOFFSET;

	for( index = 0; index < SCREENHEIGHT; index++ )
	{
		ZeroMemory( tempscreenptr, SCREENWIDTH*2 );

		tempscreenptr += VSCREENWIDTH;
	} // end index loop

	UNLOCKVS;

} // end clearscreen
*/


// Slow right now ... quick hack ...
// 16 bit version of clearvscreen ...
/*
void clearvscreen( void )
{
	word *tempscreenptr;
	int index;


	LOCKVS;

	tempscreenptr = g_vsptr;

	for( index = 0; index < VSCREENHEIGHT; index++ )
	{
		ZeroMemory( tempscreenptr, VSCREENWIDTH*2 );

		tempscreenptr += VSCREENWIDTH;
	} // end index loop

	UNLOCKVS;

} // end clearvscreen
*/


void clearscreen( void )
{
	BitBlt( memdc, 0, 0, 800, 600, tempdc, 0, 0, BLACKNESS );
	return;
} // end clearscreen


void setcursormode( byte mode )
{
        if( cursormode == mode ) return;

        cursormode = mode;

// Default options ... only changed on specific cursormodes ...
		mouseon = 1;
		cursoranimated = 0;
		cursorframe = 0;


        switch( cursormode )
                {
				default:
                case CURSOROFF:
								mouseon = 0;
                                break;

                case MENUCURSOR:
								cursorpicx = 0;
								cursorpicy = 0;

								cursoranimated = 0;
								cursortickcount = tickcount + CURSORANIMSPEED;
                                break;
/*
                case SWITCHCURSOR:
								cursorpicx = 32;
								cursorpicy = 0;

								cursoranimated = 0;
								cursortickcount = tickcount + CURSORANIMSPEED;
                                break;
*/
                } // end switch on cursormode

} // end setcursormode



/*

void showpixelformat( void )
{
	DDPIXELFORMAT ddpf;

	DDSURFACEDESC2 ddsd;

 
	ddpf.dwSize = sizeof(ddpf);
	if (SUCCEEDED(lpDDSPrimary->GetPixelFormat(&ddpf)))
	{
		sprintf( tempstr, "dwRGBBitCount: %d\ndwRBitMask: %4x\ndwGBitMask: %4x\ndwBBitMask: %4x\n\nPixelFormat: %d%d%d",
			ddpf.dwRGBBitCount, ddpf.dwRBitMask, ddpf.dwGBitMask, ddpf.dwBBitMask, rnumbits, gnumbits, bnumbits );
		MessageBox( hwndmain, tempstr, "Primary Surface", MB_OK );

		sprintf( tempstr, "rbitshift: %d\ngbitshift: %d\nbbitshift: %d\n", rbitshift, gbitshift, bbitshift );
		MessageBox( hwndmain, tempstr, "Primary Surface", MB_OK );

	} // end if getpixelformat succeeded



	ddpf.dwSize = sizeof(ddpf);
	if (SUCCEEDED(lpDDSVS->GetPixelFormat(&ddpf)))
	{
		sprintf( tempstr, "dwRGBBitCount: %d\ndwRBitMask: %4x\ndwGBitMask: %4x\ndwBBitMask: %4x\n\nPixelFormat: %d%d%d",
			ddpf.dwRGBBitCount, ddpf.dwRBitMask, ddpf.dwGBitMask, ddpf.dwBBitMask, rnumbits, gnumbits, bnumbits );
		MessageBox( hwndmain, tempstr, "Virtual Screen Surface", MB_OK );

		sprintf( tempstr, "rbitshift: %d\ngbitshift: %d\nbbitshift: %d\n", rbitshift, gbitshift, bbitshift );
		MessageBox( hwndmain, tempstr, "Virtual Screen Surface", MB_OK );

	} // end if getpixelformat succeeded



	
} // end showpixelformat


*/



/*
// 8 bit version of loadandunpackbmp() ...

byte *loadandunpackbmp( char *tempfilename )
{
	LPDIRECTDRAWSURFACE4 lpDDSTemp;
	DDSURFACEDESC2 ddsd;

	byte *srcptr;
	byte *destptr;

	int height, width;
	int pitch;


	HRESULT ddrval;









    lpDDSTemp = DDLoadBitmapSYS(lpDD4, tempfilename, 0, 0);
    if( lpDDSTemp == NULL ) cleanup( NOFILE, tempfilename );

	memset( &ddsd, 0, sizeof(ddsd) );

	ddsd.dwSize = sizeof(ddsd);
	ddrval = DDERR_WASSTILLDRAWING;

	while( ddrval == DDERR_WASSTILLDRAWING )
	{
		ddrval = lpDDSTemp->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );
	} // end keep trying until surface locked

	if( ddrval != DD_OK )
	{
		ShowDDError( "Lock() in loadandunpackbmp()", ddrval );
		cleanup( MISC, "Lock() in loadandunpackbmp" );
		return NULL;
	}

//	screenlocked = 1;

	srcptr = (BYTE *)ddsd.lpSurface;

	g_height = height = ddsd.dwHeight;
	g_width = width = ddsd.dwWidth;




// Ok, so now we should have the bitmap converted to 555 16-bit format, and we have access to the data ...
// Let's try copying it ...
//	destptr = (word *)malloc( (height*width*2L) );
//	if( destptr == NULL ) cleanup( OUTOFMEM, "loadandunpackbmp()" );

	if( (destptr = (byte *)calloc( 1, height*width )) == NULL ) cleanup(OUTOFMEM, "loadandunpackbmp()");
	memoryused += height*width;


	memcpy( destptr, srcptr, height*width );


	ddrval = lpDDSTemp->Unlock( NULL );
	if( ddrval != DD_OK )
	{
		cleanup( MISC, "Couldn't unlock surface in loadandunpackbitmap()" );
		return NULL;
	}

//	screenlocked = 0;

	if( lpDDSTemp != NULL )
	{
		lpDDSTemp->Release();
		lpDDSTemp = NULL;
	}


	return destptr;

} // end loadandunpackbmp

*/



/*
void showvscreen( void )
{
//	WORD color;
    RECT		rcRect, rcRect2;
    HRESULT		ddrval;



// Blit Virtual Screen to Back Buffer (Can i do this any faster?)
    rcRect.left = 0;
    rcRect.top = 0;
    rcRect.right = SCREENWIDTH;
    rcRect.bottom = SCREENHEIGHT;

    rcRect2.left = 0;
    rcRect2.top = 0;
    rcRect2.right = VSCREENWIDTH;
    rcRect2.bottom = VSCREENHEIGHT;


    while( 1 )
    {
//        ddrval = lpDDSBack->BltFast( 0, 0, lpDDSVS,
//            &rcRect, DDBLTFAST_NOCOLORKEY );
        ddrval = lpDDSBack->Blt( &rcRect, lpDDSVS,
            &rcRect2, NULL, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll in Blt() for VS", ddrval );
				cleanup( OK, NULL );
			} // end if couldn't restore all
			continue;
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "Blt() for VS", ddrval );
			cleanup( OK, NULL );
		}
	}


// Flip the surfaces
    while( 1 )
    {
		ddrval = lpDDSPrimary->Flip( NULL, 0 );
		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				break;
			}
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "Flip()", ddrval );
			break;
		}
    }


	waitforinput();

} // end showvscreen
*/


void systemmessage( char *textptr )
{
	strcpy( okboxtext, textptr );

//	showspriteonce( "bitmaps\\textbox.bmp", 120, 164 );
//	showbitmap( "bitmaps\\textbox.bmp", 120, 164 );

//	SETTEXTCOLOR(30,24,16);
//    myfont = ROMANTEXT;
    centertext( okboxtext, 212, 0, SCREENWIDTH );

	displayscreen();

	return;

} // end systemmessage








// Start HERE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



void drawbutton( char buttonno )
{
	return;
}

/*
// Hard coded for 8 bit, 640x480 ... 
// TODO -- Fix THIS !!!
// Not anymore ...

void drawbutton( char buttonno )
{
    int index;
    int buttonwidth;
    int textx, texty;
    char pushed;
//    word *tempscreenptr;
//    word *tempbuttonpicptr;

	HRESULT ddrval;
	RECT rcRect;


//        unsigned long screenoffset, buttonoffset;
//        unsigned int lineoff, buttoff;

// Check for type of button ...

    pushed = button[buttonno].pushed;

        switch( button[buttonno].function )
                {
                default:
                        break;

                case SLIDER:
                        if( sprite[buttonno].visible ) hidesprite(buttonno);
                        showsprite( buttonno );

                        return;

                case RADIO1:
                case RADIO2:
                case RADIO3:
                case RADIO4:
                case RADIO5:
                case RADIO6:
                case RADIO7:
                case RADIO8:

                case CHECKBOX:
                        if( pushed )
                         showbitmap( "bitmaps\\checked.pcx", button[buttonno].x1, button[buttonno].y1 );
                        else
                         showbitmap( "bitmaps\\uncheckd.pcx", button[buttonno].x1, button[buttonno].y1 );

                        return;

                } // end switch on function


	buttonwidth = button[buttonno].width;

// Same for all three sections ...
	rcRect.top = 0;
	rcRect.bottom = 32;


	if( pushed )
	{
		rcRect.top = 32;
		rcRect.bottom = 64;
	} 


// Left side ...

	rcRect.left = 0;
	rcRect.right = 3;



    while( 1 ) 
    {
        ddrval = lpDDSVS->BltFast( button[buttonno].x1, button[buttonno].y1, lpDDS[DDS_BUTTON1],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop



// Middle ...
	rcRect.left = button[buttonno].offset;

// TODO -- Shouldn't have to do this ... fix it when the offset is set ...
	if( rcRect.left < 3 ) rcRect.left = 3;

	rcRect.right = rcRect.left + buttonwidth - 6;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( button[buttonno].x1 + 3, button[buttonno].y1, lpDDS[DDS_BUTTON1],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop



// Right ...
	rcRect.left = 509;
	rcRect.right = 512;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( button[buttonno].x1 + buttonwidth - 3, button[buttonno].y1, lpDDS[DDS_BUTTON1],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	} // end loop



// Draw text ...
// DrawText:

//        mytextcolor = button[buttonno].color - button[buttonno].glowing;
// TODO -- SET UP glowing ...
//		SETTEXTCOLOR(19,13,5);

//        if( button[buttonno].glowing > 7 ) mytextcolor = button[buttonno].color - (14-button[buttonno].glowing);
        myfont = EURODARK;
		if( button[buttonno].glowing ) myfont = EURO;

        textx = button[buttonno].x1;
        texty = button[buttonno].y1 + 6;

        if( pushed )
                {
                textx += 1;
                texty += 1;

                } // end if button is pushed in

//        showtext( button[buttonno].name, textx, texty );
        centertext( button[buttonno].name, texty, textx, textx + buttonwidth );

//      myfont = ROMANTEXT;
//      mytextcolor = TEXTTAN;
//		SETTEXTCOLOR(30,24,16);


} // end drawbutton

*/

void okbox( char *textptr )
{
	MSG msg;
//	int index;


	pushgamescreen( gamescreen );
	gamescreen = GS_OKBOX;

	setcursormode( MENUCURSOR );


	strcpy( okboxtext, textptr );


//		showspriteonce( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );
//		showbitmap( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 290 );



//		SETTEXTCOLOR(30,24,16);
        myfont = EURO;
        centertext( okboxtext, 260, 0, SCREENWIDTH );

		LoadString( hInst, languageoffset+IDS_OK, string, 256 );
		strcpy( button[0].name, string );
        button[0].x1 = (SCREENWIDTH/2)-24;
        button[0].y1 = 290;
        button[0].width = 48;
        button[0].pushed = 0;
//        button[0].color = RGB16(30,24,16);
        button[0].function = BUTTONRETURN;
        button[0].variable = 0;
        button[0].memptr = NULL;
        button[0].glowing = 0;
        button[0].offset = (rand()%(504-160));


        drawbutton( 0 );

//		deletesprite( 32 );

		g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
					drawbutton( 0 );

					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	gamescreen = popgamescreen();
	refreshscreen();

	return;

} // end okbox


byte confirm( char *text )
{
	MSG msg;

	byte response;

//	int response;


// TODO -- Take this out if we decide to change this to using startgamescreen ...	
	pushgamescreen( gamescreen );
	gamescreen = GS_CONFIRM;

	setcursormode( MENUCURSOR );


//		showspriteonce( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );
//		showbitmap( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );


		LoadString( hInst, languageoffset+IDS_YES, string, 256 );
		strcpy( button[1].name, string );
        button[1].x1 = (SCREENWIDTH/2)-64;
        button[1].y1 = 290;
        button[1].width = 48;
        button[1].pushed = 0;
//        button[1].name = "Yes";
//        button[1].color = RGB16(30,24,16);
        button[1].function = BUTTONRETURN;
        button[1].variable = 0;
        button[1].memptr = NULL;
        button[1].glowing = 0;
        button[1].offset = (rand()%(504-160));

		LoadString( hInst, languageoffset+IDS_NO, string, 256 );
		strcpy( button[0].name, string );
        button[0].x1 = (SCREENWIDTH/2)+16;
        button[0].y1 = 290;
        button[0].width = 48;
        button[0].pushed = 0;
//        button[0].name = "No";
//        button[0].color = RGB16(30,24,16);
        button[0].function = BUTTONRETURN;
        button[0].variable = 0;
        button[0].memptr = NULL;
        button[0].glowing = 0;
        button[0].offset = (rand()%(504-160));

        drawbutton( 0 );
        drawbutton( 1 );


		strcpy( okboxtext, text );


//		SETTEXTCOLOR(30,24,16);
        myfont = EURO;
        centertext( okboxtext, 260, 0, SCREENWIDTH );


// Main Confirm Loop ... let's see if this works ...
	g_response = 0xFF;

    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
					drawbutton( 0 );
					drawbutton( 1 );

					displayscreen();

// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	response = g_response;

	g_response = 0xFF;

	gamescreen = popgamescreen();
	refreshscreen();

// This is set in the messagehandler for confirm ... got it ?
	return response;

} // end confirm











void addtoselectlist( char *text, byte disabled )
{
	strcpy( selectoption[numoptions].text, text );
	selectoption[numoptions].disabled = disabled;

	numoptions++;
} // end addtoselectlist



int selectlist( void )
{
	MSG msg;
	int optionno;


	pushgamescreen( gamescreen );
	gamescreen = GS_SELECTLIST;

	setcursormode( MENUCURSOR );

	listboxx = cursorx+1;
	listboxy = cursory;


	myfont = EURO;
// Determine width in pixels of list ...
	listwidth = 64;

	for( optionno = 0; optionno < numoptions; optionno++ )
	{
		if( getlength( selectoption[optionno].text ) > listwidth )
		 listwidth = getlength( selectoption[optionno].text );
	} // end optionno loop

	listwidth += 8; // Add border

// Keep from going off screen ...
	if( listboxx+listwidth > SCREENWIDTH ) listboxx -= listwidth+2;
	if( listboxy+(numoptions*14) > SCREENHEIGHT ) listboxy -= (numoptions*14)+1;
	if( listboxy < 0 ) listboxy = 0;



//	listwidth = (listwidth<<1);	// Why is listwidth the width in BYTES???

	selectedoption = 0;
	

	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
					refreshscreen();
					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	gamescreen = popgamescreen();
	refreshscreen();

	return TRUE;

} // end selectlist



int selectlistmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int optionno;

	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_RETURN:
		case VK_ESCAPE:
			g_response = FALSE;
			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN


	case WM_RBUTTONUP:
// Test to see if buttonup not on list ...
		if( (cursorx < listboxx) || (cursorx > listboxx+(listwidth>>1)) ||
			(cursory < listboxy) || (cursory > (listboxy+(numoptions*14))) )
		{
			selectedoption = 0;
			break;
		} // end if not in xbounds or above list

// If buttonup ON list, continue through to returning the response ...
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		if( selectedoption == 0 )
		{
			g_response = FALSE;
			break;
		} // end if nothing picked

		g_response = TRUE;
		break;

	case WM_MOUSEMOVE:
		if( (cursorx < listboxx) || (cursorx > listboxx+(listwidth>>1)) || (cursory < listboxy) )
		{
			selectedoption = 0;
			break;
		} // end if not in xbounds or above list

		selectedoption = ((cursory - listboxy) / 14) + 1;

		if( selectedoption > numoptions )
		{
			selectedoption = 0;
			break;
		} // end if past bottom of list

		if( selectoption[selectedoption-1].disabled )
		{
			selectedoption = 0;
			break;
		} // end if past bottom of list

		break;

	} // end switch on Windows Messages for GS_SELECTLIST


	return TRUE;

} // end selectlistmessagehandler














// initscreen()
// Allocates memory for and sets up virtual screen (vscreen, vss, & vsy)

void initscreen( void )
{




// Zero out gamescreenstack ...
		ZeroMemory( gamescreenstack, 32 );


        if( (tempdata = (byte *)malloc(65536L)) == NULL ) cleanup(OUTOFMEM, "tempdata");
        memoryused += 65536L;


} // end initscreen













void initgraphics( void )
{
//        int filehandle;
        int index;






//        buttonpicptr = loadandunpackbmp( "bitmaps\\buttons\\button1.bmp" );


        for( index = 0; index < 16; index++ )
                {
                sprite[index].beingused = 0;
                } // end index loop

        for( index = 0; index < 16; index++ )
                {
                animsprite[index].beingused = 0;
                } // end index loop




} // end initgraphics





/*
void showpalette( void )
{
	byte *tempscreenptr;

	
	int index;
	int lineindex;



	LOCKVS;


	for( lineindex = 0; lineindex < 20; lineindex++ )
	{
		tempscreenptr = g_vsptr + VSOFFSET + times800(lineindex);

		for( index = 0; index < 256; index++ )
		{
			*tempscreenptr++ = index;
			*tempscreenptr++ = index;
		} // end index loop

	} // end lineindex loop


	UNLOCKVS;


} // end showpalette
*/





// Returns output in global rgb16 struct ...

void convertpixel( word srcpixel );







