/*
gloabls.cpp
global variables for Matchblox ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include "globals.h"




// cydoor		Cydoor;				// Cydoor's class

HDC hscreendc;
HDC haddc;
HDC nagdc;
HBITMAP hadbitmap;
	


#ifdef EDITORS
// Editor globals ... removed if not including editors ...

byte editmode = 0;
int editfunction;

// Used for right mouse click select lists ...
SELECTOPTION selectoption[32];
int numoptions = 0;
byte selectedoption;
int listboxx, listboxy;
int listwidth;

#endif


MEMORYSTATUS memstatus;


#ifdef DEBUG
HANDLE debugfh;
char debugstr[128];
char debugstr2[128];
#endif


// Main Globals ...

HWND hwndmain = NULL;

HINSTANCE hInst;
BOOL bActive;	// is application active?

byte fullscreen = 0;

byte indrawscreen = 0;

dword nextframecount = 0L;
byte gamespeed = 2L;



// Directory the game is started in ...
char homedir[MAX_PATH+1];
char tempdir[MAX_PATH+1];

char lastpath[MAX_PATH+1];

char filename[MAX_PATH+1];
char sfilename[MAX_PATH+1];

HANDLE filehandle;



DWORD numofbytesread;	// for all ReadFile() operations



int memoryused = 0;


byte *tempdata;




// Clock stuff ...
UINT clockid;
volatile dword tickcount = 0L;
dword newtickcount;


dword framerate = 4L;



// Graphics variables ...
BOOL screenlocked = 0;



// Updated every time a new bmp is loaded ... copy if needed
int g_height;
int g_width;


SPRITE sprite[16];
ANIMSPRITE animsprite[16];


// Represents what part of the game the user is in (Menu, Campaign, Combat, etc.)
byte gamescreen = 0;

// Gonna try a gamescreen stack ... pushing and popping ...
byte gamescreenstack[32];

// Used for okbox() and confirm(), etc. ...
byte g_response;


// Cursor stuff ...
int cursorx = 0;
int cursory = 0;

byte cursorframe = 0;
byte cursoranimated = 0;
dword cursortickcount = 0;


byte lmb = 0;
byte rmb = 0;

byte waitingforlmbup = 0;	// I'm using this to get rid of the first occurence of WM_LBUTTONUP

byte cursormode = MENUCURSOR;

dword cursorpicx = 0;
dword cursorpicy = 0;



// Derived from GetPixelFormat ...
word rmask, gmask, bmask;
byte rbitshift, gbitshift, bbitshift;
byte rnumbits, gnumbits, bnumbits;
byte pixelformat;


word r, g, b;
word r1, g1, b1;
word r2, g2, b2;

word *rptr;
word *gptr;
word *bptr;
word *r1ptr;
word *g1ptr;
word *b1ptr;
word *r2ptr;
word *g2ptr;
word *b2ptr;


WORD g_color;
WORD color1;
WORD color2;

word *g_colorptr;






BOOL mouseon = 1;




int oldtime = 0;

int numframes = 0;
float fps;
int currtime = 0;
BOOL fpson = 0;
dword resetfps = 0;
dword frametickcount = 0;
char fpsstr[32];

char tempstr[1024];
char tempstr2[512];

// String Resources ... localization
char string[256]; // For loading temporary string resources ...
int languageoffset = ENGLISH;

char okboxtext[128];


HDC screendc;
HDC memdc;
HDC tempdc;

HDC maskdc;
HBITMAP	hbmpmask;


HBITMAP hbmp[NUMSURFACES];
HBITMAP screenbmp;


char *szsurface[NUMSURFACES] =
{
	"bitmaps\\null.bmp",
	"bitmaps\\blocks.bmp",
	"fonts\\eurofont.bmp",
	"bitmaps\\null.bmp",	// unused fonts
	"bitmaps\\null.bmp",	// unused fonts
	"bitmaps\\copyright.bmp",
	"bitmaps\\null.bmp",
	"bitmaps\\newgame.bmp",
	"bitmaps\\match2playbg.bmp",
	"bitmaps\\match3playbg.bmp",
	"bitmaps\\match4playbg.bmp",
	"bitmaps\\puzzles.bmp",
	"bitmaps\\nspgames.bmp",
	"bitmaps\\match2.bmp",
	"bitmaps\\match3.bmp",
	"bitmaps\\match4.bmp",
	"bitmaps\\title.bmp"
};


MYFONT myfonttype[NUMOFFONTS];

char myfont = EURO;
char recessed = 0;

word textr = 24;
word textg = 24;
word textb = 24;
byte textcolor = 1;
char textinbounds = 1;


byte mytextcolor = TEXTWHITE;






// DirectSound ...

BOOL soundon = 1;

char *szsoundname[NUMSOUNDS+1] = {
	NULL, 
	"wave\\click.wav",
	"wave\\sound2.wav",
	"wave\\sound3.wav",
	"wave\\sound4.wav",
	"wave\\sound5.wav",
	"wave\\sound6.wav",
	"wave\\sound7.wav",
	"wave\\sound8.wav",
	"wave\\sound9.wav",
	"wave\\oldclick.wav",
	"wave\\wingame.wav",
	"wave\\chime1.wav",
	"wave\\chime1.wav",
	"wave\\chime1.wav",
	"wave\\chime1.wav",
	"wave\\chime1.wav"
};
 




BUTTON button[16];
WORD *buttonpicptr;


byte board[100];
byte puzzleboard[110][100];
byte flagdelete[100];
byte matched[100];

byte puzzletype[110];

int numoftiles;

byte userboard[10][100];
byte userboardtype[10] = {2,2,2,2,2,2,2,2,2,2};


byte gametype;

byte nexttile;
byte reservoir[1000];
int numinreservoir;


byte distancetable[48L*48L];


int score;


FLOATINGNUMBER floatingnumber[100];


struct CHECKNODE checknode[100];
int nextavailablenode;
int numofmatches;
int numofstrands;

byte currfloatnumber;



byte higheststrand;


char lastknownname[24];


BOOL firsttime = FALSE;


char hiscorename[4][24];
int hiscore[4];


byte pushslot[20];
int countdown[20];
dword timefornewtile;
int level;

BOOL drawfast;

int numoftilesmade;


int characternumber;


OPENFILENAME ofn;
char lastfilename[MAX_PATH+1];


char *passwordlist[22] =
{
	"shellfish",
	"hospital",
	"harmony",
	"umbrella",
	"guitar",
	"telephone",
	"joystick",
	"weather",
	"journey",
	"computer",
	"giggle",
	"tomorrow",
	"doctor",
	"complex",
	"office",
	"september",
	"bookmark",
	"family",
	"mountain",
	"bonus",
	"hooray",
	"stage111"
}; // end passwordlist

int highestlevelcompleted;


byte wasoverbutton;
byte isoverbutton;


BOOL adson = FALSE;
HWND hwndad;
HWND hwndadchild = NULL;



byte selectedpuzzle;


BOOL fullclient = FALSE;
int screenoffsetx, screenoffsety;



HCURSOR	hcursor[2];


byte currtile;


char cheatcode[12] = "iamacheater";
byte cheatcodeletter;


byte currentcursor = 0;


int adx, ady;
