/*
globals.h
global declarations for Matchblox

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <mmsystem.h>

#include <commdlg.h>



// #include "resource.h"
#include "define.h"



#define NAME "MatchBlox"
#define TITLE "MatchBlox"



// extern cydoor		Cydoor;				// Cydoor's class

extern HDC hscreendc;
extern HDC haddc;
extern HDC nagdc;
extern HBITMAP hadbitmap;
	



#ifdef EDITORS
// Editor globals ... removed if not including editors ...

extern byte editmode;
extern int editfunction;

// Used for right mouse click select lists ...
extern SELECTOPTION selectoption[32];
extern int numoptions;
extern byte selectedoption;
extern int listboxx, listboxy;
extern int listwidth;

#endif


extern MEMORYSTATUS memstatus;


#ifdef DEBUG
extern HANDLE debugfh;
extern char debugstr[128];
extern char debugstr2[128];
#endif


// Main Globals ...

extern HWND hwndmain;

extern HINSTANCE hInst;
extern BOOL bActive;	// is application active?

extern byte fullscreen;

extern byte indrawscreen;

extern dword nextframecount;
extern byte gamespeed;



// Directory the game is started in ...
extern char homedir[MAX_PATH+1];
extern char tempdir[MAX_PATH+1];

extern char lastpath[MAX_PATH+1];

extern char filename[MAX_PATH+1];
extern char sfilename[MAX_PATH+1];

extern HANDLE filehandle;



extern DWORD numofbytesread;	// for all ReadFile() operations



extern int memoryused;


extern byte *tempdata;




// Clock stuff ...
extern UINT clockid;
extern volatile dword tickcount;
extern dword newtickcount;

extern dword framerate;





// Updated every time a new bmp is loaded ... copy if needed
extern int g_height;
extern int g_width;


extern SPRITE sprite[16];
extern ANIMSPRITE animsprite[16];


// Represents what part of the game the user is in (Menu, Campaign, Combat, etc.)
extern byte gamescreen;

// Gonna try a gamescreen stack ... pushing and popping ...
extern byte gamescreenstack[32];

// Used for okbox() and confirm(), etc. ...
extern byte g_response;


// Cursor stuff ...
extern int cursorx;
extern int cursory;

extern byte cursorframe;
extern byte cursoranimated;
extern dword cursortickcount;


extern byte lmb;
extern byte rmb;

extern byte waitingforlmbup;	// I'm using this to get rid of the first occurence of WM_LBUTTONUP

extern byte cursormode;

extern dword cursorpicx;
extern dword cursorpicy;



// Derived from GetPixelFormat ...
extern word rmask, gmask, bmask;
extern byte rbitshift, gbitshift, bbitshift;
extern byte rnumbits, gnumbits, bnumbits;
extern byte pixelformat;


extern word r, g, b;
extern word r1, g1, b1;
extern word r2, g2, b2;

extern word *rptr;
extern word *gptr;
extern word *bptr;
extern word *r1ptr;
extern word *g1ptr;
extern word *b1ptr;
extern word *r2ptr;
extern word *g2ptr;
extern word *b2ptr;


extern WORD g_color;
extern WORD color1;
extern WORD color2;

extern word *g_colorptr;






extern BOOL mouseon;




extern int oldtime;

extern int numframes;
extern float fps;
extern int currtime;
extern BOOL fpson;
extern dword resetfps;
extern dword frametickcount;
extern char fpsstr[32];

extern char tempstr[1024];
extern char tempstr2[512];

// String Resources ... localization
extern char string[256]; // For loading temporary string resources ...
extern int languageoffset;

extern char okboxtext[128];



extern HDC screendc;
extern HDC memdc;
extern HDC tempdc;

extern HDC maskdc;
extern HBITMAP hbmpmask;


extern HBITMAP hbmp[NUMSURFACES];
extern HBITMAP screenbmp;



extern char *szsurface[NUMSURFACES];

extern MYFONT myfonttype[NUMOFFONTS];

extern char myfont;
extern char recessed;

extern word textr;
extern word textg;
extern word textb;

extern byte textcolor;

extern char textinbounds;


extern byte mytextcolor;





// DirectSound ...

extern BOOL soundon;


extern char *szsoundname[NUMSOUNDS+1];




extern BUTTON button[16];
extern WORD *buttonpicptr;


extern byte board[100];
extern byte puzzleboard[110][100];

extern byte flagdelete[100];
extern byte matched[100];

extern byte puzzletype[110];


extern int numoftiles;


extern byte gametype;


extern byte nexttile;
extern byte reservoir[1000];
extern int numinreservoir;


extern byte distancetable[48L*48L];



extern int score;

extern FLOATINGNUMBER floatingnumber[100];



extern struct CHECKNODE checknode[100];
extern int nextavailablenode;
extern int numofmatches;
extern int numofstrands;

extern byte currfloatnumber;

extern byte higheststrand;


extern char lastknownname[24];


extern BOOL firsttime;


extern char hiscorename[4][24];
extern int hiscore[4];


extern byte pushslot[20];
extern int countdown[20];
extern dword timefornewtile;
extern int level;

extern BOOL drawfast;


extern int numoftilesmade;


extern int characternumber;


extern OPENFILENAME ofn;
extern char lastfilename[MAX_PATH+1];


extern char *passwordlist[22];

extern int highestlevelcompleted;


extern byte wasoverbutton;
extern byte isoverbutton;


extern BOOL adson;
extern HWND hwndad;
extern HWND hwndadchild;


extern byte selectedpuzzle;


extern BOOL fullclient;
extern int screenoffsetx, screenoffsety;


extern HCURSOR	hcursor[2];


extern byte editmode;


extern byte userboard[10][100];
extern byte userboardtype[10];

extern byte currtile;



extern char cheatcode[12];
extern byte cheatcodeletter;

extern byte currentcursor;


extern int adx, ady;