/*
main.cpp
main game functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include "globals.h"

#include <time.h>








// Copy VS to Back Buffer, then show cursor and fps(if on), then flip screens ...
void displayscreen( void )
{
// TODO -- Can I do something about this ?
	if( !bActive ) return;
	if( !fullscreen ) return;
	if( !fullclient ) return;





// Blit Virtual Screen to Back Buffer (Can i do this any faster?)
// Yes, if the virtual screen and back buffer are the same size ...

	screendc = GetDC( hwndmain );

	if( screenoffsetx == 0 )
	{
		BitBlt( screendc, screenoffsetx, screenoffsety,
			SCREENWIDTH, SCREENHEIGHT-60, memdc, 0, 0, SRCCOPY );
		BitBlt( screendc, screenoffsetx, screenoffsety+SCREENHEIGHT-60,
			(SCREENWIDTH/2)-(483/2), 60, memdc, 0, SCREENHEIGHT-60, SRCCOPY );
		BitBlt( screendc, screenoffsetx+(SCREENWIDTH/2)+(483/2)+1, screenoffsety+SCREENHEIGHT-60,
			(SCREENWIDTH/2)-(483/2), 60, memdc, screenoffsetx+(SCREENWIDTH/2)+(483/2)+1, SCREENHEIGHT-60, SRCCOPY );
	} // end if 800x600 (clip ad window)
	else
		BitBlt( screendc, screenoffsetx, screenoffsety, SCREENWIDTH, SCREENHEIGHT, memdc, 0, 0, SRCCOPY );


// Show fps ...
	numframes++;

	if( fpson )
	{
//		currtime = GetTickCount();
		fps = (float)numframes / ((float)frametickcount/60);

		if( resetfps >= 60 )
		{
			sprintf( fpsstr, "fps: %d", (int)fps );
			resetfps = 0;
			numframes = 0;
			frametickcount = 0;
		} // end reset every second


        SetBkColor( screendc, RGB( 0, 0, 0 ) );
        SetTextColor( screendc, RGB( 128, 128, 128 ) );
		sprintf( tempstr, "memoryused = %d", memoryused );
        TextOut( screendc, 0, 0, tempstr, strlen(tempstr) );
		
		sprintf( tempstr, "(%d, %d)  %s", cursorx, cursory, fpsstr );
		TextOut( screendc, 0, 16, tempstr, strlen(tempstr) );

		sprintf( tempstr, "highestlevelcompleted: %d", highestlevelcompleted );
		TextOut( screendc, 0, 32, tempstr, strlen(tempstr) );

		sprintf( tempstr, "currentcursor: %d", currentcursor);
		TextOut( screendc, 0, 48, tempstr, strlen(tempstr) );

		sprintf( tempstr, "GetCursor(): %d", GetCursor() );
		TextOut( screendc, 0, 64, tempstr, strlen(tempstr) );




// Show Which Game Screen ...
		switch( gamescreen )
		{
		default:				sprintf( tempstr, "No Game Screen Set" ); break;
		case GS_MAINMENU:		sprintf( tempstr, "GS_MAINMENU" ); break;
		case GS_OKBOX:			sprintf( tempstr, "GS_OKBOX" ); break;
		case GS_CONFIRM:		sprintf( tempstr, "GS_CONFIRM" ); break;
		case GS_SELECTLIST:		sprintf( tempstr, "GS_SELECTLIST" ); break;

		case GS_PLAY:			sprintf( tempstr, "GS_PLAY" ); break;

		} // end switch on gamescreen

		TextOut( screendc, 0, 480-16, tempstr, strlen(tempstr) );

		sprintf( tempstr, "cursormode %d - (%d, %d)", cursormode, cursorpicx, cursorpicy );
		TextOut( screendc, 0, 480-32, tempstr, strlen(tempstr) );

	} // end if fpson

// Please visit our sponsors!
	if( adson && (screenoffsetx != 0) )
	{
		SelectObject( nagdc, hbmp[DDS_COPYRIGHT] );
		BitBlt( screendc, screenoffsetx+400-90, (screenoffsety<<1)+600 - 60 - 12, 180, 12, nagdc, 0, 16, SRCCOPY );
	}

	ReleaseDC( hwndmain, screendc );



} // end displayscreen






// Releases all objects ...
void finiObjects( void )
{
	saveuserboards();


	if( hcursor[0] ) DeleteObject( hcursor[0] );
	if( hcursor[1] ) DeleteObject( hcursor[1] );


	if( screenbmp ) DeleteObject( screenbmp );

	if( hbmpmask ) DeleteObject( hbmpmask );
	if( maskdc ) DeleteDC( maskdc );

	if( nagdc ) DeleteDC( nagdc );

	if( tempdc ) DeleteDC( tempdc );
	if( memdc ) DeleteDC( memdc );

//	if( screendc ) ReleaseDC( hwndmain, screendc );

	for( int index = 0; index < NUMSURFACES; index++ )
	{
		if( hbmp[index] ) DeleteObject( hbmp[index] );
	} // end delete all bitmaps

//	if( adson ) closeadwindow();

} // finiObjects






// Called to exit program with 'errortype', and possible extra text ...

void cleanup( char errortype, char *text )
{
	char *caption;

	MSG msg;

	static BOOL hasbeencalled = 0;

	sprintf( debugstr, "Starting cleanup ...\n" );
	WRITETODEBUGFILE;

//	if( adson ) closeadwindow();


		switch( errortype )
		{
			case OK:
				finiObjects();
				PostQuitMessage(0);
#ifdef DEBUG
				sprintf( debugstr, "\nGame Exit ... OK!\n" );
				WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );

				CloseHandle( debugfh );
#endif
				goto StartLoop;

			case OUTOFMEM:
				caption = "Out of Memory.";
				break;
			case NOFILE:
				caption = "Unable to access file.";
				break;
			case MISC:
				caption = "Miscellaneous Error.";
				break;

			default:
				caption = "Unknown Error.";
				break;

		} // end switch on errortype


#ifdef DEBUG
			sprintf( debugstr, "\nGame Exit ... \n%s\n%s\n", caption, text );
			WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );

			CloseHandle( debugfh );
#endif

		
			finiObjects();
			MessageBox( hwndmain, text, caption, MB_OK|MB_TOPMOST|MB_ICONEXCLAMATION );
			SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );

			PostQuitMessage(0);


			
//			DestroyWindow( hwndmain );
//			return;

StartLoop:

    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						DestroyWindow( hwndmain );

						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

    } // end main loop



} // end cleanup









BOOL setup( void )
{
	initscreen();

	initgraphics();

	inittext();

// TODO -- Add all kinds of other initialization here ...

	return TRUE;
} // end setup




// doInit - do work required for every instance of the application: create the window, initialize data
static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    HWND		hwnd;
	WNDCLASSEX wcex;


// Make client area cover ENTIRE screen ...
	RECT windowrect;
	int width, height;

	windowrect.left = 0;
	windowrect.top = 0;
	windowrect.right = GetSystemMetrics( SM_CXSCREEN );
	windowrect.bottom = GetSystemMetrics( SM_CYSCREEN );

	AdjustWindowRect( &windowrect, WS_VISIBLE|WS_POPUP|WS_SYSMENU, FALSE );

	width = windowrect.right - windowrect.left;
	height = windowrect.bottom - windowrect.top;



/*
	sprintf( debugstr, "windowrect: (%d, %d) - (%d, %d)\n",
		windowrect.left, windowrect.top, windowrect.right, windowrect.bottom );
	WRITETODEBUGFILE;
*/

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WindowProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_LGICON);
//	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= GetStockBrush(BLACK_BRUSH);
	wcex.lpszMenuName	= NAME;
	wcex.lpszClassName	= NAME;
	wcex.hIconSm		= LoadIcon(hInstance, (LPCTSTR)IDI_SMICON);

    RegisterClassEx( &wcex );
    
    /*
     * create a window
     */
    hwnd = CreateWindowEx(
        WS_EX_TOPMOST,
		NAME,
		TITLE,
		WS_VISIBLE|WS_POPUP|WS_SYSMENU,
		windowrect.left,
		windowrect.top,
        width,
        height,
		NULL,
		NULL,
		hInstance,
		NULL );

    if( !hwnd )	return FALSE;

	hwndmain = hwnd;

	// Remove harmful system menu items ...
	RemoveMenu( GetSystemMenu( hwndmain, FALSE ), SC_SIZE, MF_BYCOMMAND );
	RemoveMenu( GetSystemMenu( hwndmain, FALSE ), SC_MOVE, MF_BYCOMMAND );



// Create memdc

	screendc = GetDC( NULL );


// Check for required screen resolution (800x600x16) ...
	if( (GetSystemMetrics( SM_CXSCREEN ) < 800 ) || (GetSystemMetrics( SM_CYSCREEN ) < 600) ||
		(GetDeviceCaps( screendc, BITSPIXEL ) < 15) )
	{
		ReleaseDC( hwnd, screendc );
		
		switch( MessageBox( hwnd, "Your monitor must be set to a resolution of at least 800 x 600 with 16 bits of color depth to play MatchBlox.\n\nWould you like instructions on how to do this now?", "Screen Resolution too low ...",
			MB_ICONEXCLAMATION|MB_YESNO|MB_TOPMOST ) )
		{
		default:
		case IDNO:
			cleanup( OK, NULL );

		case IDYES:
			ShellExecute( hwndmain, "open", "Help\\ChangeRes.htm", NULL, NULL, SW_SHOWNORMAL );
			cleanup( OK, NULL );

		} // end switch on response

	} // end if not enough


// Create virtual window ... make max size of 800 x 600 ...

	memdc = CreateCompatibleDC( screendc );
	tempdc = CreateCompatibleDC( screendc );

	nagdc = CreateCompatibleDC( screendc );

	screenbmp = CreateCompatibleBitmap( screendc, 800, 600 );
	SelectObject( memdc, screenbmp );

	BitBlt( memdc, 0, 0, 800, 600, screendc, 0, 0, BLACKNESS );

	ReleaseDC( hwnd, NULL );


	// Load Bitmaps ...
	for( int index = 0; index < NUMSURFACES; index++ )
	{
		hbmp[index] = (HBITMAP)LoadImage( hInstance, szsurface[index], IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE );
		if( hbmp[index] == NULL )
		{
			sprintf( tempstr, "Failed to load '%s'.", szsurface[index] );
			cleanup( MISC, tempstr );
		}

	} // end index loop


// Create Monochrome BMP for text masking ...
	maskdc = CreateCompatibleDC( screendc );
	hbmpmask = CreateBitmap( 32, 32, 1, 1, NULL );	// Monochrome

	SelectObject( maskdc, hbmpmask );

//	SetFocus( hwnd );
//    ShowWindow( hwnd, nCmdShow );
//    UpdateWindow( hwnd );


    return TRUE;

} /* doInit */



/*
 * WinMain - initialization, message loop
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPSTR lpCmdLine, int nCmdShow)
{
//	int index;
    MSG		msg;
	HANDLE filehandle;



    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

	srand( (unsigned)time( NULL ) );


#ifdef DEBUG
		debugfh = CreateFile("debug.log",           
             GENERIC_WRITE,                // open for writing 
             0,                            // do not share 
             NULL,                         // no security 
             CREATE_ALWAYS,                // overwrite existing 
             FILE_ATTRIBUTE_NORMAL |       // normal file 
             FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
             NULL);                        // no attr. template 

		if( debugfh == INVALID_HANDLE_VALUE )
		{
			FormatMessage( 
			    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			    FORMAT_MESSAGE_FROM_SYSTEM | 
			    FORMAT_MESSAGE_IGNORE_INSERTS,
			    NULL,
			    GetLastError(),
			    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			    (LPTSTR)&tempstr,
			    0,
			    NULL );

			sprintf( debugstr, "Error opening debug.log ... %s\n", tempstr );
			WRITETODEBUGFILE;

			cleanup( NOFILE, "debug.log" );
		}

		sprintf( debugstr, "Game Start ... ver 1.06\n\n" );
		if( !WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL ) ) cleanup( NOFILE, "debug.log" );

#endif


    if( !doInit( hInstance, nCmdShow ) ) return FALSE;


	loaduserboards();


// Set priority to highest ...
// Only if needed!
//	SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );

// Set screen offsets ...
	screenoffsetx = (GetSystemMetrics( SM_CXSCREEN ) - VSCREENWIDTH) / 2;
	screenoffsety = (GetSystemMetrics( SM_CYSCREEN ) - VSCREENHEIGHT) / 2;


// make a global copy for use by dialog boxes ...
	hInst = hInstance;

// Load Cursors ...
	hcursor[0] = LoadCursor( NULL, IDC_ARROW );
	hcursor[1] = LoadCursor( hInst, "HANDCURSOR" );
//	hcursor[1] = LoadCursor( NULL, IDC_UPARROW );


/*	sprintf( debugstr, "LoadCursor(0): %d\n", hcursor[0] );
	WRITETODEBUGFILE;
	sprintf( debugstr, "LoadCursor(1): %d\n", hcursor[1] );
	WRITETODEBUGFILE;
*/

// Remember the home directory ...
	GetCurrentDirectory( MAX_PATH+1, homedir );


// Do graphics and game specific init ...
	if( !setup() ) return FALSE;


// Setup and start timer from winmm.lib
	clockid = timeSetEvent( 1000/60, 0, mytimer, NULL, TIME_PERIODIC | TIME_CALLBACK_FUNCTION );
	if( clockid == NULL ) cleanup( MISC, "Unable to set Multimedia Timer!" );

	fullscreen = 1;

	resetfps = 0;
	strcpy( fpsstr, "Testing ..." );

	initdistance();


/*
// Setup DirectSound, and load all static sounds ...
	if( InitDSound( hwndmain, NULL ) == FALSE ) cleanup( NOSOUND, "Can't initialize DirectSound!" );

// Test Secondary streaming buffer (for music?) ...
//	if( SetupStreamBuffer( "wave\\starter1.wav" ) == FALSE ) cleanup( NOSOUND, "Unable to play wave file!" );



	for( int soundno = 1; soundno < NUMSOUNDS+1; soundno++ )
	{
sprintf( debugstr, "Loading Sound %d ... %s\n", soundno, szsoundname[soundno] );
WRITETODEBUGFILE;
		if( LoadSound( soundno, szsoundname[soundno] ) == FALSE )
		{
			cleanup( NOSOUND, "Unable to load sound!" );
		}

	} // end load all static sounds
*/


// Load in HI Scores from file ...
	strcpy( hiscorename[0], "Anonymous" );
	strcpy( hiscorename[1], "Anonymous" );
	strcpy( hiscorename[2], "Anonymous" );
	strcpy( hiscorename[3], "Anonymous" );

	hiscore[0] = 0;
	hiscore[1] = 0;
	hiscore[2] = 0;
	hiscore[3] = 0;


	filehandle = CreateFile( "data\\hiscores.dat",           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 

	if( filehandle != INVALID_HANDLE_VALUE )
	{
	    if( !ReadFile( filehandle, hiscorename, 24 * 4, &numofbytesread, NULL ) ) cleanup(NOFILE, "Reading hiscores.dat.");
	    if( !ReadFile( filehandle, hiscore, sizeof(int) * 4, &numofbytesread, NULL ) ) cleanup(NOFILE, "Reading hiscores.dat.");

		CloseHandle( filehandle );
	} // end if is a valid file
		

// Load in Puzzles from file ...
	ZeroMemory( puzzleboard, 110L*100L );
	loadpuzzles( "data\\puzzles.dat" );

	strcpy( lastfilename, "data\\puzzles.dat" );


// Start Game here ...

//	blankscreen();


// TODO -- Put this back in ?!?!?
//	startgamescreen( GS_MAINMENU );
	gamescreen = GS_MAINMENU;
//	showbitmap( "bitmaps\\mainmenu.bmp", 0, 0 );

	intro();

	showgametypes();
	showhiscores();
	showquitbutton();
	displayscreen();

	setcursormode( MENUCURSOR );



	wasoverbutton = 0;
	isoverbutton = 0;

/*

  Main Loop ...

*/


    while( 1 )
    {
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
				finiObjects();
				return msg.wParam;
			} // end if WM_QUIT received

		TranslateMessage(&msg);
		DispatchMessage(&msg);

		}
		else if( bActive )
		{
//			showgametypes();	// To keep them animating ...
//			showhiscores();
//			showquitbutton();
//			displayscreen();
		} // end if bActive

		else
		{
			// make sure we go to sleep if we have nothing else to do
			WaitMessage();
		} // end if NOT bActive

    } // end main loop

} // end WinMain



void CALLBACK mytimer( UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2 )
{
		tickcount++;	// Is this accurate enough ?
		frametickcount++;
		resetfps++;

/*
		if( cursoranimated )
		{
			if( cursortickcount == tickcount )
			{
				if( ++cursorframe == 8 ) cursorframe = 0;
				cursortickcount = tickcount + CURSORANIMSPEED;
			} // end if time to change cursorframe
		} // end if cursoranimated
*/

} // end mytimer






void waitfor( int numticks )
{
	dword newclock;


	newclock = tickcount + numticks;

	while( tickcount < newclock ) { };

} // end waitfor












void playgame( void )
{
	MSG msg;
	int index;

	int surfaceno;



	pushgamescreen( gamescreen );
	gamescreen = GS_PLAY;


	strcpy( lastknownname, "Anonymous" );

	level = 0;

	wasoverbutton = 0;
	isoverbutton = 0;

	SetCursor( hcursor[0] );
	currentcursor = 0;

// StartPlay:

	cheatcodeletter = 0;

	currtile = 1;	// for USEREDIT

	ZeroMemory( floatingnumber, sizeof(FLOATINGNUMBER) * 100 );

//	adson = FALSE;

	switch( gametype )
	{
	default:
		surfaceno = DDS_PLAYBG4;
		break;
	case USEREDIT:
	case USERPLAY:
	case BUMPIT:
		surfaceno = DDS_PLAYBG2;
		break;
	case BUMPIT3:
		surfaceno = DDS_PLAYBG3;
		break;
	case BUMPIT4:
		surfaceno = DDS_PLAYBG4;
		break;
	} 

//	DDReLoadBitmap( lpDDS[surfaceno], szsurface[surfaceno] );
	// Reload Background ...
	DeleteObject( hbmp[surfaceno] );

	hbmp[surfaceno] = (HBITMAP)LoadImage( hInst, szsurface[surfaceno], IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE );
	if( hbmp[surfaceno] == NULL )
	{
		sprintf( tempstr, "Failed to load '%s'.", szsurface[surfaceno] );
		cleanup( MISC, tempstr );
	}


	drawbuttonsonbg();


//	showbitmap( "bitmaps\\playbg.bmp", 0, 0 );
	drawbg();

//	drawcharacter( characternumber, 40, 240, NORMAL );

	drawscore();

	score = 0;

	ZeroMemory( board, 100 );
	
	for( int blockspace = 0; blockspace < 100; blockspace++ )
	{
		board[blockspace] = rand()%9;

		if( (gametype == PUSHIT) && (rand()%2) ) board[blockspace] = 0;

	} // end fill board randomly


// Load in puzzle game
	if( gametype == PUZZLE )
	{
		memcpy( board, puzzleboard[level], 100L );
	} // end if PUZZLE game

	if( gametype == USEREDIT )
	{
		memcpy( board, userboard[level], 100L );
	} // end if PUZZLE game



// Fade in ...
	ShowCursor( FALSE );

	memset( flagdelete, 1, 100 );
	for( index = 7; index > 0; index-- )
	{
		drawboard( index );
		displayscreen();
	} // end index loop
	memset( flagdelete, 0, 100 );

	ShowCursor( TRUE );


// Count tiles ...
	numoftiles = 0;
	for( index = 0; index < 100; index++ )
	{
		if( board[index] ) numoftiles++;
	} // end index loop


	drawboard( 0 );

	firsttime = TRUE;	// To keep points from being scored ...
	checkboard();
	firsttime = FALSE;

	setcursormode( MENUCURSOR );

	numoftilesmade = 0;
	timefornewtile = tickcount + 180;	// 3 sec delay for new tile ... only used in PUSHIT


	drawfast = FALSE;

	InvalidateRect( hwndmain, NULL, FALSE );


	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						cleanup( OK, NULL );
/*						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
*/					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);

				}
				else if( bActive )
				{
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

/*
	switch( g_response )
	{
	case WINGAME:
		goto StartPlay;

	} // end switch on g_response
*/

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...

//	if( adson ) closeadwindow();

	gamescreen = popgamescreen();
	refreshscreen();

	return;

} // end playgame




void drawboard( byte outline )
{
	int blockspace, blockx, blocky;
	byte blocknumber;
	int yoffset;


	blockspace = 0;


	SelectObject( tempdc, hbmp[1] );


	for( blocky = 0; blocky < 10; blocky++ )
	{
	for( blockx = 0; blockx < 10; blockx++ )
	{
		blocknumber = board[blockspace];

// Blt Block ...

		yoffset = 0;
		if( outline && flagdelete[blockspace] ) yoffset = (outline<<5)+(outline<<3);

		BitBlt( memdc, 200 + (blockx<<5)+(blockx<<3), 100 + (blocky<<5)+(blocky<<3), 40, 40,
			tempdc, (blocknumber<<5)+(blocknumber<<3), yoffset, SRCCOPY );

		blockspace++;
	} // end blockx loop
	} // end blocky loop

	if( (gametype == USEREDIT) && !lmb && !rmb )
	{
		if( (cursorx > 200) && (cursorx < 600) && (cursory > 100) && (cursory < 500) )
		{
			blockx = (cursorx-200) / 40;
			blocky = (cursory-100) / 40;

			BitBlt( memdc, 200 + (blockx<<5)+(blockx<<3), 100 + (blocky<<5)+(blocky<<3), 40, 40,
				tempdc, (currtile<<5)+(currtile<<3), 200, SRCCOPY );

		} // end if over board

	} // end draw selected tile


//	if( !drawfast ) waitfor( 3 );

} // end drawboard




int checkboard( void )
{
	BOOL deletedblocks = FALSE;

	int boardx, boardy, boardspace;


	ZeroMemory( flagdelete, 100 );
	ZeroMemory( matched, 100 );

	currfloatnumber = 0;


	numofstrands = 0;
	higheststrand = 0;

	for( boardy = 0; boardy < 10; boardy++ )
	{
		for( boardx = 0; boardx < 10; boardx++ )
		{
			if( checkspace( boardx, boardy ) == TRUE )
			{
				numofstrands++;
				deletedblocks = TRUE;
			}

		} // end boardx loop

	} // end boardy loop


// Multiply Scores by number of strands ...
	currfloatnumber = 0;
	while( floatingnumber[currfloatnumber].active )
	{
		floatingnumber[currfloatnumber].amount *= numofstrands;
		currfloatnumber++;
	} // end loop through active floaters




	if( deletedblocks == TRUE )
	{
		int pathno;


		if( firsttime )
		{
//			ShowCursor( FALSE );

			for( pathno = 0; pathno < 8; pathno++ )
			{
				newtickcount = tickcount + 3;

				drawbg();
//				drawcharacter( characternumber, 40, 240, NORMAL );
				drawscore();
				drawboard( pathno );

				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end pathno loop

		} // end if firsttime
		else
		{
			higheststrand *= numofstrands;

			if( higheststrand > 8 ) higheststrand = 8;
			PLAYMATCH( higheststrand );


//			ShowCursor( FALSE );

			myfont = EURO;

			for( pathno = 0; pathno < 8; pathno++ )
			{
				newtickcount = tickcount + 3;

				drawbg();

//				drawcharacter( characternumber, 40, 240, HAPPY );
				drawscore();
				drawboard( pathno );

			// Draw floating scores ...
				currfloatnumber = 0;
				while( floatingnumber[currfloatnumber].active )
				{
					mytextcolor = floatingnumber[currfloatnumber].color;
					itoa( floatingnumber[currfloatnumber].amount, tempstr, 10 );
					centertext( tempstr, floatingnumber[currfloatnumber].pathy[pathno], 
						floatingnumber[currfloatnumber].pathx[pathno], floatingnumber[currfloatnumber].pathx[pathno] );
	
					currfloatnumber++;
				} // end loop through active floaters
	
				displayscreen();


				if( pathno == 0 )
				{
					dword newclock;
					newclock = tickcount + 30;

					while( tickcount < newclock ) {};
//					while( tickcount < newclock ) displayscreen();

				} // end pause while scores are displayed

				while( tickcount < newtickcount ) {};

			} // end pathno loop

			// Add all floaters to main score ...
			currfloatnumber = 0;
			while( floatingnumber[currfloatnumber].active )
			{
				score += floatingnumber[currfloatnumber].amount;
	
				currfloatnumber++;
			} // end loop through active floaters

		} // end if NOT firsttime
	
	
		for( boardspace = 0; boardspace < 100; boardspace++ )
		{
			if( flagdelete[boardspace] )
			{
				board[boardspace] = 0;
			} // end if this space is now empty
	
		} // end boardspace

		drawbg();
//		drawcharacter( characternumber, 40, 240, NORMAL );
		drawscore();

		drawboard( 0 );
		displayscreen();


//		ShowCursor( TRUE );

		// Check for win ...
		for( boardspace = 0; boardspace < 100; boardspace++ )
		{
			if( board[boardspace] ) break;
		} // end boardspace


		if( boardspace == 100 ) return CHECKWIN; // Found no blocks

// Check for game lose ...
		if( nomorematches() )
		{
			return CHECKLOSE;
		} // end if no more matches found


	} // end if did delete some blocks



	return 0;	// Continue playing ...

} // end checkboard




void drawbg( void )
{
	int surfaceno;



	switch( gametype )
	{
	default:
		surfaceno = DDS_PLAYBG4;
		break;
	case USEREDIT:
	case USERPLAY:
	case BUMPIT:
		surfaceno = DDS_PLAYBG2;
		break;
	case BUMPIT3:
		surfaceno = DDS_PLAYBG3;
		break;
	case BUMPIT4:
		surfaceno = DDS_PLAYBG4;
		break;
	} 


	SelectObject( tempdc, hbmp[surfaceno] );

// Top ...
	BitBlt( memdc, 0, 0, 800, 100, tempdc, 0, 0, SRCCOPY );

// Bottom ...
	BitBlt( memdc, 0, 500, 800, 100, tempdc, 0, 500, SRCCOPY );

// Left ...
	BitBlt( memdc, 0, 100, 200, 400, tempdc, 0, 100, SRCCOPY );

// Right ...
	BitBlt( memdc, 600, 100, 200, 400, tempdc, 600, 100, SRCCOPY );


	if( gametype == PUZZLE )
	{
	} // end show match type for THIS puzzle

	switch( gametype )
	{
	case PUZZLE:
		myfont = EURO;

		mytextcolor = TEXTORANGE;
		sprintf( tempstr, "STAGE %d", level+1 );
		centertext( tempstr, 260, 0, 170 );

		mytextcolor = TEXTGREEN;
		sprintf( tempstr, "Match %d", puzzletype[level] );
		centertext( tempstr, 280, 0, 170 );
		break;

	case USEREDIT:
	case USERPLAY:
		myfont = EURO;

		mytextcolor = TEXTORANGE;
		sprintf( tempstr, "STAGE %d", level+1 );
		centertext( tempstr, 260, 0, 170 );

		mytextcolor = TEXTGREEN;
		sprintf( tempstr, "Match %d", userboardtype[level] );
		centertext( tempstr, 280, 0, 170 );
		break;

	case BUMPIT:
		sprintf( tempstr, "Match 2" );
		myfont = EURO;
		mytextcolor = TEXTGREEN;
		centertext( tempstr, 290, 0, 170 );
		break;

	case BUMPIT3:
		sprintf( tempstr, "Match 3" );
		myfont = EURO;
		mytextcolor = TEXTGREEN;
		centertext( tempstr, 290, 0, 170 );
		break;

	case BUMPIT4:
		sprintf( tempstr, "Match 4" );
		myfont = EURO;
		mytextcolor = TEXTGREEN;
		centertext( tempstr, 290, 0, 170 );
		break;

	} // end switch on gametype


	// Please visit our sponsors!
	if( adson && (screenoffsetx == 0) )
	{
		SelectObject( nagdc, hbmp[DDS_COPYRIGHT] );
		BitBlt( memdc, (SCREENWIDTH/2)-90, SCREENHEIGHT-60-12, 180, 12, nagdc, 0, 16, SRCCOPY );
	}

} // end drawbg



void drawscore( void )
{
	if( gametype == USEREDIT )
	{
		int tileindex;
		int srcx, srcy;
		int destx;

		srcx = 40;
		destx = (SCREENWIDTH/2) - 160;

		for( tileindex = 1; tileindex < 9; tileindex++ )
		{
			srcy = 200;
			if( tileindex == currtile ) srcy = 0;

			SelectObject( tempdc, hbmp[1] );
			BitBlt( memdc, destx, 20, 40, 40, tempdc, srcx, srcy, SRCCOPY );

			srcx += 40;
			destx += 40;

		} // end tileindex;

		// Instead of showing score, show selected block
	}
	else
	{
		itoa( score, tempstr, 10 );
		myfont = EURO;
		mytextcolor = TEXTWHITE;
		centertext( tempstr, 24, 0, 800 );
	}
} // end drawscore




void drawbuttons( void )
{

// Quit Button ...		
	if( (cursorx > 778) && (cursorx < 798) && (cursory > 2) && (cursory < 22) )
	{
		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 778, 2, 20, 20, tempdc, 360, 0, SRCCOPY );
	} // end if on quit button


// Minimize Button ...
	if( (cursorx > 756) && (cursorx < 776) && (cursory > 2) && (cursory < 22) )
	{
		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 756, 2, 20, 20, tempdc, 380, 0, SRCCOPY );
	} // end if on minimize button




// Back to Menu button ...
	if( (cursorx > 655) && (cursorx < 775) && (cursory > 304) && (cursory < 336) )
	{
		SelectObject( tempdc, hbmp[DDS_NEWGAME] );
		BitBlt( memdc, 655, 304, 120, 32, tempdc, 0, 288, SRCCOPY );
	} // end if over BACK button


// Restart or Clear ...
	if( gametype == USEREDIT )
	{
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 264) && (cursory < 296) )
		{
			SelectObject( tempdc, hbmp[DDS_NEWGAME] );
			BitBlt( memdc, 655, 264, 120, 32, tempdc, 0, 416, SRCCOPY );
		} // end New Game button
	}
	else
	{
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 264) && (cursory < 296) )
		{
			SelectObject( tempdc, hbmp[DDS_NEWGAME] );
			BitBlt( memdc, 655, 264, 120, 32, tempdc, 0, 256, SRCCOPY );
		} // end New Game button
	}


// Next or Prev
	if( (gametype == USEREDIT) || (gametype == USERPLAY) )
	{
		if( (cursorx > 25) && (cursorx < 145) )
		{
			if( (cursory > 320) && (cursory < 352) )
			{
				SelectObject( tempdc, hbmp[DDS_NEWGAME] );
				BitBlt( memdc, 25, 320, 120, 32, tempdc, 0, 448, SRCCOPY );
			} // end prev

			if( (cursory > 360) && (cursory < 392) )
			{
				SelectObject( tempdc, hbmp[DDS_NEWGAME] );
				BitBlt( memdc, 25, 360, 120, 32, tempdc, 0, 480, SRCCOPY );
			} // end prev

		} // end if in x range

	} // end if next or prev on screen


// Password Button ...		
	if( gametype == PUZZLE )
	{
		if( (cursorx > 25) && (cursorx < 145) && (cursory > 304) && (cursory < 336) )
		{
			SelectObject( tempdc, hbmp[DDS_NEWGAME] );
			BitBlt( memdc, 25, 304, 120, 32, tempdc, 0, 320, SRCCOPY );
		} // end Password button

	} // end if password game


} // end drawbuttons





void checkcursor( void )
{

	while( 1 )
	{
		if( (cursorx > adx) && (cursorx < adx+483) && (cursory > ady) && (cursory < ady+60) )
		{
			break;
		} // end Ad


	// BACK button ...
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 304) && (cursory < 336) )
		{
			if( wasoverbutton == 1 ) break;
			wasoverbutton = 1;
			SetCursor( hcursor[1] );
			currentcursor = 1;
			break;
		} // end if over BACK button
	
	
	// New Game Button ...		
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 264) && (cursory < 296) )
		{
			if( wasoverbutton == 2 ) break;
			wasoverbutton = 2;
			SetCursor( hcursor[1] );
			currentcursor = 1;
			break;
		} // end New Game button
	
	
	
	
	// Password Button ...		
		if( gametype == PUZZLE )
		{
			if( (cursorx > 25) && (cursorx < 145) && (cursory > 304) && (cursory < 336) )
			{
				if( wasoverbutton == 3 ) break;
				wasoverbutton = 3;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end Password button
	
		} // end if password game


	// EDITOR buttons ...
		if( (gametype == USEREDIT) || (gametype == USERPLAY) )
		{
			if( (cursorx > 25) && (cursorx < 145) )
			{
				if( (cursory > 100) && (cursory < 132) )
				{
					if( wasoverbutton == 10 ) break;
					wasoverbutton = 10;
					SetCursor( hcursor[1] );
					currentcursor = 1;
					break;
				} // end edit button

				if( (cursory > 140) && (cursory < 172) )
				{
					if( wasoverbutton == 11 ) break;
					wasoverbutton = 11;
					SetCursor( hcursor[1] );
					currentcursor = 1;
					break;
				} // end play button

				if( (cursory > 320) && (cursory < 352) )
				{
					if( wasoverbutton == 12 ) break;
					wasoverbutton = 12;
					SetCursor( hcursor[1] );
					currentcursor = 1;
					break;
				} // end prev button

				if( (cursory > 360) && (cursory < 392) )
				{
					if( wasoverbutton == 13 ) break;
					wasoverbutton = 13;
					SetCursor( hcursor[1] );
					currentcursor = 1;
					break;
				} // end next button

			} // end if in x range

		} // end next prev

	// Selected Tile ...
		if( gametype == USEREDIT )
		{
			if( (cursorx > 240) && (cursorx < 560) && (cursory > 20) && (cursory < 60) )
			{
				if( wasoverbutton == 8 ) break;
				wasoverbutton = 8;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end selected tile

			if( (cursorx > 200) && (cursorx < 600) && (cursory > 100) && (cursory < 500) )
			{
				if( wasoverbutton == 9 ) break;
				wasoverbutton = 9;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end place tile


			if( (cursorx > 25) && (cursorx < 145) && (cursory > 278) && (cursory < 300) )
			{
				if( wasoverbutton == 14 ) break;
				wasoverbutton = 14;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end change gametype

	
		} // end if USEREDIT
		else
		{
		
		// Top Row ...		
			if( (cursorx > 200) && (cursorx < 600) && (cursory > 70) && (cursory < 100) )
			{
				if( wasoverbutton == 4 ) break;
				wasoverbutton = 4;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end if on top row
		
		
		// Bottom Row ...		
			if( (cursorx > 200) && (cursorx < 600) && (cursory > 500) && (cursory < 530) )
			{
				if( wasoverbutton == 5 ) break;
				wasoverbutton = 5;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end if on bottom row
		
		
		// Left Side ...		
			if( (cursorx > 170) && (cursorx < 200) && (cursory > 100) && (cursory < 500) )
			{
				if( wasoverbutton == 6 ) break;
				wasoverbutton = 6;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
			} // end if on left side
		
		
		// Right Side ...		
			if( (cursorx > 600) && (cursorx < 630) && (cursory > 100) && (cursory < 500) )
			{
				if( wasoverbutton == 7 ) break;
				wasoverbutton = 7;
				SetCursor( hcursor[1] );
				currentcursor = 1;
				break;
		 	} // end if on right side

		} // end if NOT USEREDIT


		wasoverbutton = 0;
		SetCursor( hcursor[0] );
		currentcursor = 0;

		break;
	} // end while 1 loop

} // end void checkcursor






void checkmenucursor( void )
{
	wasoverbutton = isoverbutton;


	while( 1 )
	{
		if( (cursorx > 280) && (cursorx < 520) && (cursory > 160) && (cursory < 220) )
		{
			isoverbutton = 1;
			currentcursor = 1;
			break;
		} // end if MATCH 2

		if( (cursorx > 280) && (cursorx < 520) && (cursory > 240) && (cursory < 300) )
		{
			isoverbutton = 2;
			currentcursor = 1;
			break;
		} // end if MATCH 3

		if( (cursorx > 280) && (cursorx < 520) && (cursory > 320) && (cursory < 380) )
		{
			isoverbutton = 3;
			currentcursor = 1;
			break;
		} // end if MATCH 4

		if( (cursorx > 280) && (cursorx < 520) && (cursory > 400) && (cursory < 460) )
		{
			isoverbutton = 4;
			currentcursor = 1;
			break;
		} // end if PUZZLES

		if( (cursorx > 60) && (cursorx < 220) && (cursory > 440) && (cursory < 520) )
		{
			isoverbutton = 5;
			currentcursor = 1;
			break;
		} // end if LOGO

		if( (cursorx > SCREENWIDTH-220) && (cursorx < SCREENWIDTH-60) && (cursory > 464) && (cursory < 464+56) )
		{
			isoverbutton = 6;
			currentcursor = 1;
			break;
		} // end if LOGO

		if( (cursorx > 580) && (cursorx < 740) && (cursory > 200) && (cursory < 280) )
		{
			isoverbutton = 7;
			currentcursor = 1;
			break;
		} // end if USEREDIT

		if( (cursorx > 100) && (cursorx < 180) && (cursory > 200) && (cursory < 280) )
		{
			isoverbutton = 8;
			currentcursor = 1;
			break;
		} // end if HELP

		if( (cursorx > (SCREENWIDTH/2)-80) && (cursorx < (SCREENWIDTH/2)+80) &&
			(cursory > SCREENHEIGHT-80-32) && (cursory < SCREENHEIGHT-80) )
		{
			isoverbutton = 9;
			currentcursor = 1;
			break;
		} // end if RESET

		if( (cursorx > 778) && (cursorx < 798) && (cursory > 2) && (cursory < 22) )
		{
			isoverbutton = 10;
			currentcursor = 0;
			break;
		} // end Quit button

		if( (cursorx > 756) && (cursorx < 776) && (cursory > 2) && (cursory < 22) )
		{
			isoverbutton = 11;
			currentcursor = 0;
			break;
		} // end Minimize button

		if( (cursorx > adx) && (cursorx < adx+483) && (cursory > ady) && (cursory < ady+60) )
		{
			isoverbutton = 12;
			currentcursor = 1;
			break;
		} // end Ad




		isoverbutton = 0;
		currentcursor = 0;

		break;

	} // end while 1 loop


	if( wasoverbutton == isoverbutton ) return;

	switch( isoverbutton )
	{
	default:
	case 0:
		showgametypes();
		showhiscores();
		showquitbutton();

		InvalidateRect( hwndmain, NULL, FALSE );

		SetCursor( hcursor[currentcursor] );
		break;

	case 1:
	case 2:
	case 3:
	case 4:
		showgametypes();
		showhiscores();
		showquitbutton();

		InvalidateRect( hwndmain, NULL, FALSE );

		PLAYBUTTONOVER;
		SetCursor( hcursor[currentcursor] );
		break;

	case 5:
	case 6:
	case 7:
	case 8:
	case 9:
		showgametypes();
		showhiscores();
		showquitbutton();

		InvalidateRect( hwndmain, NULL, FALSE );

		PLAYBUTTONOVER;
		SetCursor( hcursor[currentcursor] );
		break;

	case 10:
	case 11:
		showquitbutton();
		SetCursor( hcursor[currentcursor] );

		InvalidateRect( hwndmain, NULL, FALSE );
		break;

	} // end switch on isoverbutton

} // end checkmenucursor








int getdistance( int x1, int y1, int x2, int y2 )
{
        short int xoff, yoff;

        xoff = x2 - x1 + 24;
        yoff = y2 - y1 + 24;

// TESTES! What the fuck?!?!
        if( (xoff<0) || (xoff>47) || (yoff<0) || (yoff>47) ) return( 35 );

        return( distancetable[ (yoff<<5) + (yoff<<4) + xoff ] );
} // end getdistance





void initdistance( void )
{
    int x, y;
    double height, width, hyp;
    char distance;

    int tableindex = 0;


        for( y = 0; y < 48; y++ )
        {

            for( x = 0; x < 48; x++ )
            {
            height = (double)(fabs(y - 24));
            width = (double)(fabs(x - 24));

            hyp = sqrt( ((height*height) + (width*width)) );

            distance = (byte)hyp;

            distancetable[tableindex] = distance;

            tableindex++;
            } // end x loop

        } // end y loop

} // end initdistance



// Finds all matching children for a given space. Sets all blocks to be deleted and initializes
// floating scores ... Returns TRUE or FALSE (was block removed?)
int checkspace( int x, int y )
{
	int boardspace;


//sprintf( debugstr, "checkspace( %d, %d )\n", x, y );
//WRITETODEBUGFILE;


// TODO: OPT!
	boardspace = (y<<3)+(y<<1) + x;

	if( matched[boardspace] )
	{
//sprintf( debugstr, " Cancelled! Space already matched!\n");
//WRITETODEBUGFILE;
		return NULL;
	}
	if( (board[boardspace] == 0) )
	{
//sprintf( debugstr, " Cancelled! Space Empty!\n");
//WRITETODEBUGFILE;
		return NULL;
	}


	ZeroMemory( checknode, sizeof(CHECKNODE)*100 );


// Init starting node ...
	checknode[1].color = board[boardspace];
	checknode[1].x = x;
	checknode[1].y = y;

	matched[boardspace] = TRUE;

	nextavailablenode = 2;

// Fill in tree data ...
	numofmatches = 0;
	getchildren( 1 );


	if( numofmatches > higheststrand ) higheststrand = numofmatches;


	switch( gametype )
	{
	case BUMPIT:
		if( numofmatches > 0 )
		{
			removeblock( 1 );
			return TRUE;
		}
		break;

	case PUSHIT:
	case BUMPIT3:
		if( numofmatches > 1 )
		{
			removeblock( 1 );
			return TRUE;
		}
		break;

	case PUZZLE:
		if( numofmatches >= puzzletype[level]-1 )
		{
			removeblock( 1 );
			return TRUE;
		}
		break;

	case USERPLAY:
		if( numofmatches >= userboardtype[level]-1 )
		{
			removeblock( 1 );
			return TRUE;
		}
		break;

	case BUMPIT4:
		if( numofmatches > 2 )
		{
			removeblock( 1 );
			return TRUE;
		}
		break;

	} // end switch on gametype


	return FALSE;

} // end checkspace



// Removes block and ALL children ...
void removeblock( int nodeno )
{
	int pathno;
	int boardy, boardx, boardspace;

	int xincrement, yincrement; // for movement


//sprintf( debugstr, "removeblock( %d )\n", nodeno );
//WRITETODEBUGFILE;



// Remove children ...
	if( checknode[nodeno].childno[0] ) removeblock( checknode[nodeno].childno[0] );
	if( checknode[nodeno].childno[1] ) removeblock( checknode[nodeno].childno[1] );
	if( checknode[nodeno].childno[2] ) removeblock( checknode[nodeno].childno[2] );
	if( checknode[nodeno].childno[3] ) removeblock( checknode[nodeno].childno[3] );


	boardx = checknode[nodeno].x;
	boardy = checknode[nodeno].y;

	boardspace = (boardy<<3)+(boardy<<1) + boardx;

	flagdelete[boardspace] = 1;


// Set up new floating score ...
	floatingnumber[currfloatnumber].amount = ((numofmatches+1)<<3) + ((numofmatches+1)<<1);
	floatingnumber[currfloatnumber].color = board[boardspace]-1;


	floatingnumber[currfloatnumber].active = 1;
// Turn off the one in front (will be reactivated if used, otherwise stop here) ...
	floatingnumber[currfloatnumber + 1].active = 0;


	floatingnumber[currfloatnumber].x = 220L + (boardx<<5)+(boardx<<3);
	floatingnumber[currfloatnumber].y = 110L + (boardy<<5)+(boardy<<3);

	xincrement = (400L - floatingnumber[currfloatnumber].x) / 8L; 
	yincrement = (16L - floatingnumber[currfloatnumber].y) / 8L; 

	for( pathno = 0; pathno < 8; pathno++ )
	{
		floatingnumber[currfloatnumber].pathx[pathno] = 
			floatingnumber[currfloatnumber].x + (xincrement * pathno);
	
		floatingnumber[currfloatnumber].pathy[pathno] = 
			floatingnumber[currfloatnumber].y + (yincrement * pathno);

	} // end pathno loop

	currfloatnumber++;


} // end removeblock



// Recursive function ... returns number of children found that match
int getchildren( int nodeno )
{
	int boardspace;
	byte checkcolor;
	int checkx, checky;

/*
sprintf( debugstr, "getchildren( %d )\n", nodeno );
WRITETODEBUGFILE;
sprintf( debugstr, " checknode[%d].x = %d\n", nodeno, checknode[nodeno].x );
WRITETODEBUGFILE;
sprintf( debugstr, " checknode[%d].y = %d\n", nodeno, checknode[nodeno].y );
WRITETODEBUGFILE;
*/

	checkcolor = checknode[nodeno].color;


//CHECKUP:
	checkx = checknode[nodeno].x;
	checky = checknode[nodeno].y - 1;

	if( checky < 0 ) goto CHECKDOWN;

	boardspace = (checky<<3)+(checky<<1) + checkx;

	if( matched[boardspace] ) goto CHECKDOWN;

	if( board[boardspace] == checkcolor )
	{
		matched[boardspace] = TRUE;
		numofmatches++;

		// Create new node and assign as child ...
		checknode[nodeno].childno[0] = nextavailablenode;
		checknode[nodeno].numofchildren++;

		checknode[nextavailablenode].parentno = nodeno;
		checknode[nextavailablenode].color = checkcolor;
		checknode[nextavailablenode].x = checkx;
		checknode[nextavailablenode].y = checky;

		nextavailablenode++;
		getchildren( nextavailablenode - 1 );
	} // end if match found


CHECKDOWN:
	checkx = checknode[nodeno].x;
	checky = checknode[nodeno].y + 1;

	if( checky > 9 ) goto CHECKLEFT;

	boardspace = (checky<<3)+(checky<<1) + checkx;

	if( matched[boardspace] ) goto CHECKLEFT;

	if( board[boardspace] == checkcolor )
	{
		matched[boardspace] = TRUE;
		numofmatches++;

		// Create new node and assign as child ...
		checknode[nodeno].childno[1] = nextavailablenode;
		checknode[nodeno].numofchildren++;

		checknode[nextavailablenode].parentno = nodeno;
		checknode[nextavailablenode].color = checkcolor;
		checknode[nextavailablenode].x = checkx;
		checknode[nextavailablenode].y = checky;

		nextavailablenode++;
		getchildren( nextavailablenode - 1 );
	} // end if match found


CHECKLEFT:
	checkx = checknode[nodeno].x - 1;
	checky = checknode[nodeno].y;

	if( checkx < 0 ) goto CHECKRIGHT;

	boardspace = (checky<<3)+(checky<<1) + checkx;

	if( matched[boardspace] ) goto CHECKRIGHT;

	if( board[boardspace] == checkcolor )
	{
		matched[boardspace] = TRUE;
		numofmatches++;

		// Create new node and assign as child ...
		checknode[nodeno].childno[2] = nextavailablenode;
		checknode[nodeno].numofchildren++;

		checknode[nextavailablenode].parentno = nodeno;
		checknode[nextavailablenode].color = checkcolor;
		checknode[nextavailablenode].x = checkx;
		checknode[nextavailablenode].y = checky;

		nextavailablenode++;
		getchildren( nextavailablenode - 1 );
	} // end if match found



CHECKRIGHT:
	checkx = checknode[nodeno].x + 1;
	checky = checknode[nodeno].y;

	if( checkx > 9 ) goto CHECKSDONE;

	boardspace = (checky<<3)+(checky<<1) + checkx;

	if( matched[boardspace] ) goto CHECKSDONE;

	if( board[boardspace] == checkcolor )
	{
		matched[boardspace] = TRUE;
		numofmatches++;

		// Create new node and assign as child ...
		checknode[nodeno].childno[3] = nextavailablenode;
		checknode[nodeno].numofchildren++;

		checknode[nextavailablenode].parentno = nodeno;
		checknode[nextavailablenode].color = checkcolor;
		checknode[nextavailablenode].x = checkx;
		checknode[nextavailablenode].y = checky;

		nextavailablenode++;
		getchildren( nextavailablenode - 1 );
	} // end if match found


CHECKSDONE:

	return checknode[nodeno].numofchildren;

} // end getchildren





BOOL CALLBACK hiscoredialogfunc( HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam )
{


// SET g_response when ending dialog!
	switch( message )
	{
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDCANCEL:
			sprintf( lastknownname, "Anonymous" );
			EndDialog( hdwnd, 0 );
			return 1;

		case IDOK:
			GetDlgItemText( hdwnd, IDC_EDIT, lastknownname, 12 );
			EndDialog( hdwnd, 0 );
			return 1;
		} // end switch on which control

		break;

	case WM_INITDIALOG:
// TODO: Set to last known name ...
		SetDlgItemText( hdwnd, IDC_EDIT, lastknownname );
		return 1;

	} // end switch on Windows Message to hiscoredialogfunc

	return 0;

} // end hiscoredialogfunc





void showhiscores( void )
{
	myfont = EURO;

	itoa( hiscore[0], tempstr, 10 );
	mytextcolor = TEXTWHITE;
	showtextjr( tempstr, 520, 210 );
	
	mytextcolor = TEXTORANGE;
	showtext( hiscorename[0], 280, 210 );


	itoa( hiscore[1], tempstr, 10 );
	mytextcolor = TEXTWHITE;
	showtextjr( tempstr, 520, 290 );
	
	mytextcolor = TEXTORANGE;
	showtext( hiscorename[1], 280, 290 );


	itoa( hiscore[2], tempstr, 10 );
	mytextcolor = TEXTWHITE;
	showtextjr( tempstr, 520, 370 );
	
	mytextcolor = TEXTORANGE;
	showtext( hiscorename[2], 280, 370 );


	itoa( hiscore[3], tempstr, 10 );
	mytextcolor = TEXTWHITE;
	showtextjr( tempstr, 520, 450 );
	
	mytextcolor = TEXTBLUE;
	showtext( hiscorename[3], 280, 450 );


} // end showhiscores




void showgametypes( void )
{
	myfont = EURO;

	int yoffset, xoffset;




// Match 2 ...
	SelectObject( tempdc, hbmp[DDS_MATCH2] );

	yoffset = 0;
	if( (cursorx > 280) && (cursorx < 520) && (cursory > 160) && (cursory < 220) )
		yoffset = 60;

	BitBlt( memdc, 280, 160, 240, 60, tempdc, 0, yoffset, SRCCOPY );



// Match 3 ...
	SelectObject( tempdc, hbmp[DDS_MATCH3] );

	yoffset = 0;
	if( (cursorx > 280) && (cursorx < 520) && (cursory > 240) && (cursory < 300) )
		yoffset = 60;

	BitBlt( memdc, 280, 240, 240, 60, tempdc, 0, yoffset, SRCCOPY );



// Match 4 ...
	SelectObject( tempdc, hbmp[DDS_MATCH4] );

	yoffset = 0;
	if( (cursorx > 280) && (cursorx < 520) && (cursory > 320) && (cursory < 380) )
		yoffset = 60;

	BitBlt( memdc, 280, 320, 240, 60, tempdc, 0, yoffset, SRCCOPY );



// Puzzles ...
	SelectObject( tempdc, hbmp[DDS_PUZZLES] );

	yoffset = 0;
	if( (cursorx > 280) && (cursorx < 520) && (cursory > 400) && (cursory < 460) )
		yoffset = 60;

	BitBlt( memdc, 280, 400, 240, 60, tempdc, 0, yoffset, SRCCOPY );



	SelectObject( tempdc, hbmp[DDS_NSPGAMES] );

// NSP Logo ...
	yoffset = 0;
	if( (cursorx > 60) && (cursorx < 220) && (cursory > 440) && (cursory < 520) )
		yoffset = 80;

	BitBlt( memdc, 60, 440, 160, 80, tempdc, 0, yoffset, SRCCOPY );


// Cydoor Logo ...
	yoffset = 400;
	if( (cursorx > SCREENWIDTH-220) && (cursorx < SCREENWIDTH-60) && (cursory > 464) && (cursory < 464+56) )
		yoffset = 400+56;

	BitBlt( memdc, SCREENWIDTH-220, 464, 160, 56, tempdc, 0, yoffset, SRCCOPY );


// Help ...
	xoffset = 0;
	if( (cursorx > 100) && (cursorx < 180) && (cursory > 200) && (cursory < 280) )
		xoffset += 80;

	BitBlt( memdc, 100, 200, 80, 80, tempdc, xoffset, 160, SRCCOPY );


// Board Editor ...
	yoffset = 240;
	if( (cursorx > 580) && (cursorx < 740) && (cursory > 200) && (cursory < 280) )
		yoffset = 320;

	BitBlt( memdc, 580, 200, 160, 80, tempdc, 0, yoffset, SRCCOPY );


// Reset Scores ...
	yoffset = 512;
	if( (cursorx > (SCREENWIDTH/2)-80) && (cursorx < (SCREENWIDTH/2)+80) &&
		(cursory > SCREENHEIGHT-80-32) && (cursory < SCREENHEIGHT-80) )
		yoffset = 512+32;

	BitBlt( memdc, (SCREENWIDTH/2)-80, SCREENHEIGHT-80-32, 160, 32, tempdc, 0, yoffset, SRCCOPY );


// Please visit our sponsors!
	if( adson && (screenoffsetx == 0) )
	{
		SelectObject( nagdc, hbmp[DDS_COPYRIGHT] );
		BitBlt( memdc, (SCREENWIDTH/2)-90, SCREENHEIGHT-60-12, 180, 12, nagdc, 0, 16, SRCCOPY );
	}


} // end showgametypes



void showquitbutton( void )
{
	SelectObject( tempdc, hbmp[1] );


// Quit button
	if( (cursorx > 778) && (cursorx < 798) && (cursory > 2) && (cursory < 22) )
		BitBlt( memdc, 778, 2, 20, 20, tempdc, 360, 0, SRCCOPY );
	else
		BitBlt( memdc, 778, 2, 20, 20, tempdc, 360, 300, SRCCOPY );


// Minimize button
	if( (cursorx > 756) && (cursorx < 776) && (cursory > 2) && (cursory < 22) )
		BitBlt( memdc, 756, 2, 20, 20, tempdc, 380, 0, SRCCOPY );
	else
		BitBlt( memdc, 756, 2, 20, 20, tempdc, 380, 300, SRCCOPY );


} // end showquitbutton






void intro( void )
{
//	int slidersx, slidersy;
	int nspx;
	int frame;
	byte soundnumber;

	RECT rcRect;



	setcursormode( CURSOROFF );

	ShowCursor( FALSE );


//	if( adson ) closeadwindow();


	nspx = 0;

	soundnumber = 0;

	SelectObject( tempdc, hbmp[DDS_SLIDERS] );

	for( frame = 1; frame < 16; frame++ )
	{
		newtickcount = tickcount + 3;

		clearscreen();

// Title ...
		rcRect.left = 0;
		rcRect.top = 100;
		if( frame == 15 ) rcRect.top -= 100;

		rcRect.right = (frame<<5)+(frame<<3);
		if( rcRect.right > 400 ) rcRect.right = 400;
		rcRect.bottom = rcRect.top + 100;

// Blt Title ...

		BitBlt( memdc, 800-((frame<<5)+(frame<<3)), 200, rcRect.right - rcRect.left, 100, tempdc, 0, rcRect.top, SRCCOPY );

//SkipLogo:

		displayscreen();

		switch( soundnumber )
		{
		case 0:		CLICK1;	break;
		case 1:		CLICK2;	break;
		case 2:		CLICK3;	break;
		case 3:		CLICK4;	break;
		} // end soundnumber switch
		soundnumber++;
		if( soundnumber > 3 ) soundnumber = 0;

		while( tickcount < newtickcount ) {};
	} // end frame loop


	waitfor( 24 );


	for( frame = 1; frame < 18; frame++ )
	{
		newtickcount = tickcount + 3;

		clearscreen();

		rcRect.top = 0;
		rcRect.bottom = 100;
		rcRect.left = 0;
		rcRect.right = 400;

// Blt Title ...
		BitBlt( memdc, 200, 200 - ((frame<<3)+(frame<<1)), 400, 100, tempdc, 0, 0, SRCCOPY );


		switch( soundnumber )
		{
		case 0:		CLICK1;	break;
		case 1:		CLICK2;	break;
		case 2:		CLICK3;	break;
		case 3:		CLICK4;	break;
		} // end soundnumber switch
		soundnumber++;
		if( soundnumber > 3 ) soundnumber = 0;


		displayscreen();

		while( tickcount < newtickcount ) {};

	} // end frame loop



// Blt Copyright ...
	SelectObject( nagdc, hbmp[DDS_COPYRIGHT] );
	BitBlt( memdc, (SCREENWIDTH/2)-128, 112, 256, 16, nagdc, 0, 0, SRCCOPY );


	ShowCursor( TRUE );


//	if( !adson ) openadwindow();


	showgametypes();
	showhiscores();
	showquitbutton();

	InvalidateRect( hwndmain, NULL, FALSE );


} // end intro








int makenewtile( void )
{
	byte blocknumber;
	int slotno;


	for( slotno = 0; slotno < 20; slotno++ )
	{
		if( !pushslot[slotno] ) break;
	} // end check for full slots

	if( slotno == 20 ) return FALSE;


Start:
	slotno = rand()%20;
	if( pushslot[slotno] ) goto Start;


// TODO: Change to nexttile ...
	blocknumber = reservoir[0];

	if( blocknumber == 0 ) return FALSE;

	pushslot[slotno] = blocknumber;
	countdown[slotno] = tickcount + 120 - (level*2);

	numoftilesmade++;
	if( numoftilesmade > level * 12 )
	{
		level++;
	} // end new level


// Fill in reservoir ...
	for( slotno = 0; slotno < numinreservoir; slotno++ )
	{
		reservoir[slotno] = reservoir[slotno+1];
	} // end slotno loop

	numinreservoir--;

	return TRUE;

} // end makenewtile


int pushtiles( void )
{
	byte blocknumber;
	int slotno;
	int boardx, boardy, boardspace;
	int availablespace;


	for( slotno = 0; slotno < 10; slotno++ )
	{
		if( !pushslot[slotno] ) continue;
		if( tickcount < countdown[slotno] ) continue;

		blocknumber = pushslot[slotno];
		boardx = 0;
		boardy = slotno;

		boardspace = (boardy<<3)+(boardy<<1) + boardx;

		// Look for available space ...
		for( availablespace = 0; availablespace < 10; availablespace++ )
		{
			if( board[boardspace] == 0 ) break;
			boardspace++;
		} // end look for available space

		if( availablespace == 10 ) continue;	// No room!

		// Move blocks over
		for( boardx = availablespace; boardx > 0; boardx-- )
		{
			board[boardspace] = board[boardspace-1];
			boardspace--;
		} // end boardx loop

		board[boardspace] = blocknumber;
		pushslot[slotno] = 0;
		countdown[slotno] = 0;

	} // end slotno loop



	for( slotno = 10; slotno < 20; slotno++ )
	{
		if( !pushslot[slotno] ) continue;
		if( tickcount < countdown[slotno] ) continue;

		blocknumber = pushslot[slotno];
		boardx = 9;
		boardy = slotno - 10;

		boardspace = (boardy<<3)+(boardy<<1) + boardx;

		// Look for available space ...
		for( availablespace = 9; availablespace >= 0; availablespace-- )
		{
			if( board[boardspace] == 0 ) break;
			boardspace--;
		} // end look for available space

		if( availablespace == -1 ) continue;	// No room!

		// Move blocks over
		for( boardx = availablespace; boardx < 9; boardx++ )
		{
			board[boardspace] = board[boardspace+1];
			boardspace++;
		} // end boardx loop

		board[boardspace] = blocknumber;
		pushslot[slotno] = 0;
		countdown[slotno] = 0;

	} // end slotno loop


	checkboard();


	return TRUE;

} // end pushtiles




void drawsliderbuttons( void )
{
	int boardx, boardy;



// Top Row ...		
	if( (cursorx > 200) && (cursorx < 600) && (cursory > 70) && (cursory < 100) )
	{
		boardx = (cursorx-200) / 40;

		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 200 + (boardx<<5)+(boardx<<3), 70, 40, 30, tempdc, 360, 20, SRCCOPY );

		return;
	} // end if on top row


// Bottom Row ...		
	if( (cursorx > 200) && (cursorx < 600) && (cursory > 500) && (cursory < 530) )
	{
		boardx = (cursorx-200) / 40;

		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 200 + (boardx<<5)+(boardx<<3), 500, 40, 30, tempdc, 360, 50, SRCCOPY );

		return;
	} // end if on bottom row


// Left Side ...		
	if( (cursorx > 170) && (cursorx < 200) && (cursory > 100) && (cursory < 500) )
	{
		boardy = (cursory-100) / 40;

		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 170, 100 + (boardy<<5)+(boardy<<3), 30, 40, tempdc, 360, 80, SRCCOPY );

		return;
	} // end if on left side


// Right Side ...		
	if( (cursorx > 600) && (cursorx < 630) && (cursory > 100) && (cursory < 500) )
	{
		boardy = (cursory-100) / 40;

		SelectObject( tempdc, hbmp[1] );
		BitBlt( memdc, 600, 100 + (boardy<<5)+(boardy<<3), 30, 40, tempdc, 360, 120, SRCCOPY );

		return;
 	} // end if on right side

}








int loadpuzzles( char *filename )
{
	HANDLE fh;
	OPENFILENAME ofn;

	char tempfilename[MAX_PATH+1];
	HRESULT result;

	strcpy( tempfilename, filename );

	if( tempfilename[0] == NULL )
	{
		ZeroMemory( &ofn, sizeof(OPENFILENAME) );

		ofn.lStructSize = sizeof( OPENFILENAME );
		ofn.hwndOwner = hwndmain;
//		ofn.lpstrFilter = "Rush Hour Cities\0*.cty\0\0";
		strcpy( tempfilename, "*.dat" );
		ofn.lpstrFile = tempfilename;
		ofn.nMaxFile = MAX_PATH+1;
		ofn.lpstrInitialDir = "Data";
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
		ofn.lpstrDefExt = "dat";
		ofn.lpstrTitle = "Load Puzzle File ...";

//		lpDD7->FlipToGDISurface();

		ShowCursor( TRUE );
		result = GetOpenFileName( &ofn );
		ShowCursor( FALSE );

		if( result == 0 ) return FALSE;

		strcpy( tempfilename, ofn.lpstrFile );

	} // end if empty string ... get filename


	fh = CreateFile( tempfilename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 

	if( fh == INVALID_HANDLE_VALUE ) cleanup( NOFILE, tempfilename );

	if( !ReadFile( fh, puzzleboard, 100L * 100L, &numofbytesread, NULL ) ) cleanup( NOFILE, tempfilename );
	if( !ReadFile( fh, puzzletype, 100L, &numofbytesread, NULL ) ) cleanup( NOFILE, tempfilename );

// Bonus puzzles!
	ReadFile( fh, &puzzleboard[100], 10L * 100L, &numofbytesread, NULL );
	ReadFile( fh, &puzzletype[100], 10L, &numofbytesread, NULL );


	CloseHandle( fh );

	return TRUE;	

} // end loadpuzzles


int savepuzzles( char *filename )
{
	HANDLE fh;
	OPENFILENAME ofn;

	char tempfilename[MAX_PATH+1];
	HRESULT result;

	strcpy( tempfilename, filename );

	if( tempfilename[0] == NULL )
	{
		ZeroMemory( &ofn, sizeof(OPENFILENAME) );

		ofn.lStructSize = sizeof( OPENFILENAME );
		ofn.hwndOwner = hwndmain;
//		ofn.lpstrFilter = "Rush Hour Cities\0*.cty\0\0";
		strcpy( tempfilename, "*.dat" );
		ofn.lpstrFile = tempfilename;
		ofn.nMaxFile = MAX_PATH+1;
		ofn.lpstrInitialDir = "Data";
		ofn.Flags = OFN_NOCHANGEDIR;
		ofn.lpstrDefExt = "dat";
		ofn.lpstrTitle = "Save Puzzle File ...";

//		lpDD7->FlipToGDISurface();

		ShowCursor( TRUE );
		result = GetSaveFileName( &ofn );
		ShowCursor( FALSE );

		if( result == 0 ) return FALSE;

		strcpy( tempfilename, ofn.lpstrFile );

	} // end if empty string ... get filename



	memcpy( puzzleboard[level], board, 100L );

	fh = CreateFile( tempfilename,           // create MYFILE.TXT 
            GENERIC_WRITE,                // open for writing 
            0,                            // do not share 
            NULL,                         // no security 
            CREATE_ALWAYS,                // overwrite existing 
            FILE_ATTRIBUTE_NORMAL |       // normal file 
            FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
            NULL );                        // no attr. template 

	if( fh == INVALID_HANDLE_VALUE ) return FALSE;

	if( !WriteFile( fh, puzzleboard, 100L*100L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}

	if( !WriteFile( fh, puzzletype, 100L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}

// Bonus Puzzles!

	if( !WriteFile( fh, &puzzleboard[100], 10L*100L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}

	if( !WriteFile( fh, &puzzletype[100], 10L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}



	CloseHandle( fh );

	strcpy( lastfilename, tempfilename );

	return TRUE;

} // end savepuzzles











void drawallpuzzles( byte outline )
{
	int blockspace, blockx, blocky;
	byte blocknumber;


	int screenx, screeny;
	int puzzleno;
	int puzzlex, puzzley;

	BOOL cursoroverpuzzle = FALSE;




	mytextcolor = TEXTGREEN;
	puzzleno = 0;

	for( puzzley = 0; puzzley < 11; puzzley++ )
	{
	for( puzzlex = 0; puzzlex < 10; puzzlex++ )
	{
		screeny = 100 + (puzzley * 40);
		screenx = 200 + (puzzlex * 40);

		if( (cursorx > screenx) && (cursorx < screenx+40) && (cursory > screeny) && (cursory < screeny+40) )
			cursoroverpuzzle = TRUE;

		if( selectedpuzzle == (puzzley*10) + puzzlex ) cursoroverpuzzle = TRUE;


	SelectObject( tempdc, hbmp[1] );

	blockspace = 0;

	for( blocky = 0; blocky < 10; blocky++ )
	{
	for( blockx = 0; blockx < 10; blockx++ )
	{
		blocknumber = puzzleboard[puzzleno][blockspace];


		if( cursoroverpuzzle )
			BitBlt( memdc, screenx + (blockx<<2), screeny + (blocky*4), 4, 4,
				tempdc, (blocknumber<<5)+(blocknumber<<3) + 8, 8, SRCCOPY );
		else
			BitBlt( memdc, screenx + (blockx<<2), screeny + (blocky*4), 4, 4,
				tempdc, (blocknumber<<5)+(blocknumber<<3) + 8, 168, SRCCOPY );

		blockspace++;


	} // end blockx loop
	} // end blocky loop


// Show Match number ...
		sprintf( tempstr, "%d", puzzletype[puzzleno] );
		centertext( tempstr, screeny+10, screenx, screenx+40 );


		puzzleno++;

		cursoroverpuzzle = FALSE;
	
	} // end puzzley loop
	} // end puzzlex loop


} // end drawallpuzzles





int arrangepuzzles( void )
{
	MSG msg;



	pushgamescreen( gamescreen );
	gamescreen = GS_ARRANGEPUZZLES;

	setcursormode( MENUCURSOR );

	selectedpuzzle = 0xFF;

	g_response = 0xFF;


	clearscreen();

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						cleanup( OK, NULL );
					} // end if WM_QUIT received

					TranslateMessage(&msg); 
					DispatchMessage(&msg);

					drawallpuzzles( 0 );
					displayscreen();
				}
				else if( bActive && fullscreen )
				{
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	gamescreen = popgamescreen();

	drawboard( 0 );
	refreshscreen();

	return TRUE;

} // end arrangepuzzles



void dopuzzlehiscore( void )
{
	HANDLE hiscorefh;
	HRESULT result;


	setcursormode( CURSOROFF );
	displayscreen();
	displayscreen();
//	lpDD7->FlipToGDISurface();
	result = DialogBox( hInst, "NEWHISCORE", hwndmain, hiscoredialogfunc );

	if( *lastknownname == NULL )
	{
		strcpy( lastknownname, "ANONYMOUS" );
	} // end if NOTHING entered

	strcpy( hiscorename[gametype], lastknownname );
	hiscore[gametype] = score;

	setcursormode( MENUCURSOR );

// Save hi score file here ...
	sprintf( debugstr, "Saving Game high scores ...\n\n" );
	WRITETODEBUGFILE;

	hiscorefh = CreateFile("data\\hiscores.dat",           // create MYFILE.TXT 
	            GENERIC_WRITE,                // open for writing 
			    0,                            // do not share 
				NULL,                         // no security 
				CREATE_ALWAYS,                // overwrite existing 
				FILE_ATTRIBUTE_NORMAL |       // normal file 
				FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
				NULL);                        // no attr. template 

	if( hiscorefh == INVALID_HANDLE_VALUE ) cleanup( NOFILE, "data\\hiscores.dat" );

	if( !WriteFile( hiscorefh, hiscorename, 24*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );
	if( !WriteFile( hiscorefh, hiscore, sizeof(int)*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );

	CloseHandle( hiscorefh );

} // end dopuzzlehiscore




void showpassword( void )
{
	HRESULT result;


	setcursormode( CURSOROFF );
	displayscreen();
	displayscreen();
//	lpDD7->FlipToGDISurface();
	result = DialogBox( hInst, "SHOWPASSWORD", hwndmain, showpassworddialogfunc );

	setcursormode( MENUCURSOR );

} // end showpassword



BOOL CALLBACK showpassworddialogfunc( HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam )
{


	switch( message )
	{
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
		case IDCANCEL:
			EndDialog( hdwnd, 0 );
			return 1;
		} // end switch on which control

		break;

	case WM_INITDIALOG:
		sprintf( tempstr, "Password to Stage %d ...", level+1 );
		SetDlgItemText( hdwnd, IDC_STAGENO, tempstr );
		SetDlgItemText( hdwnd, IDC_PASSWORD, passwordlist[(level-1)/5] );
		return 1;

	} // end switch on Windows Message to showpassworddialogfunc

	return 0;

} // end showpassworddialogfunc




void enterpassword( void )
{
	HRESULT result;


	score = 0;

	setcursormode( CURSOROFF );
	displayscreen();
	displayscreen();
//	lpDD7->FlipToGDISurface();
	result = DialogBox( hInst, "enterpassword", hwndmain, enterpassworddialogfunc );

	setcursormode( MENUCURSOR );

} // end enterpassword



BOOL CALLBACK enterpassworddialogfunc( HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	int passwordno;


	switch( message )
	{
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDCANCEL:
			EndDialog( hdwnd, 0 );
			return 1;

		case IDOK:
			GetDlgItemText( hdwnd, IDC_PASSWORD, tempstr, 16 );

			for( int index = 0; index < 21; index++ )
			{
				if( _stricmp( tempstr, passwordlist[index] ) == 0 )
				{
					level = ((index+1)*5);
					break;
				} // end if match

			} // end index loop

			EndDialog( hdwnd, 0 );
			return 1;
		} // end switch on which control

		break;

	case WM_INITDIALOG:
		passwordno = ((highestlevelcompleted+1) / 5);

		if( passwordno > 0 )
			SetDlgItemText( hdwnd, IDC_PASSWORD, passwordlist[passwordno-1] );

		return 1;

	} // end switch on Windows Message to enterpassworddialogfunc

	return 0;

} // end enterpassworddialogfunc






void drawbuttonsonbg( void )
{
	HDC srcdc;


	int boardx, boardy;

	int surfaceno;

// Draw buttons on background ...
	switch( gametype )
	{
	default:
		surfaceno = DDS_PLAYBG4;
		break;
	case USEREDIT:
	case USERPLAY:
	case BUMPIT:
		surfaceno = DDS_PLAYBG2;
		break;
	case BUMPIT3:
		surfaceno = DDS_PLAYBG3;
		break;
	case BUMPIT4:
		surfaceno = DDS_PLAYBG4;
		break;
	} 


	SelectObject( tempdc, hbmp[surfaceno] );


	srcdc = CreateCompatibleDC( tempdc );
	SelectObject( srcdc, hbmp[DDS_NEWGAME] );

	switch( gametype )
	{
	case USEREDIT:
		// clear
		BitBlt( tempdc, 655, 264, 120, 32, srcdc, 0, 160, SRCCOPY );
		// edit
		BitBlt( tempdc, 25, 100, 120, 32, srcdc, 0, 352, SRCCOPY );
		// play
		BitBlt( tempdc, 25, 140, 120, 32, srcdc, 0, 128, SRCCOPY );
		// prev
		BitBlt( tempdc, 25, 320, 120, 32, srcdc, 0, 192, SRCCOPY );
		// next
		BitBlt( tempdc, 25, 360, 120, 32, srcdc, 0, 224, SRCCOPY );
		break;

	case USERPLAY:
		// restart
		BitBlt( tempdc, 655, 264, 120, 32, srcdc, 0, 0, SRCCOPY );
		// edit
		BitBlt( tempdc, 25, 100, 120, 32, srcdc, 0, 96, SRCCOPY );
		// play
		BitBlt( tempdc, 25, 140, 120, 32, srcdc, 0, 384, SRCCOPY );
		// prev
		BitBlt( tempdc, 25, 320, 120, 32, srcdc, 0, 192, SRCCOPY );
		// next
		BitBlt( tempdc, 25, 360, 120, 32, srcdc, 0, 224, SRCCOPY );
		break;

	case PUZZLE:
		// restart
		BitBlt( tempdc, 655, 264, 120, 32, srcdc, 0, 0, SRCCOPY );
		// password
		BitBlt( tempdc, 25, 304, 120, 32, srcdc, 0, 64, SRCCOPY );
		break;

	default:
		// restart
		BitBlt( tempdc, 655, 264, 120, 32, srcdc, 0, 0, SRCCOPY );
		break;

	} // end switch on gametype



	// Back to Menu
	BitBlt( tempdc, 655, 304, 120, 32, srcdc, 0, 32, SRCCOPY );

	

// Draw slider buttons ...
	SelectObject( srcdc, hbmp[1] );

// Top row ...
	for( boardx = 0; boardx < 10; boardx++ )
	{
		BitBlt( tempdc, 200 + (boardx<<5)+(boardx<<3), 70, 40, 30, srcdc, 360, 160, SRCCOPY );
	}

// Bottom row ...
	for( boardx = 0; boardx < 10; boardx++ )
	{
		BitBlt( tempdc, 200 + (boardx<<5)+(boardx<<3), 500, 40, 30, srcdc, 360, 190, SRCCOPY );
	}

// Left side ...
	for( boardy = 0; boardy < 10; boardy++ )
	{
		BitBlt( tempdc, 170, 100 + (boardy<<5)+(boardy<<3), 30, 40, srcdc, 360, 220, SRCCOPY );
	}

// Right side ...
	for( boardy = 0; boardy < 10; boardy++ )
	{
		BitBlt( tempdc, 600, 100 + (boardy<<5)+(boardy<<3), 30, 40, srcdc, 360, 260, SRCCOPY );
	}


// Quit and minimize buttons ...
	BitBlt( tempdc, 778, 2, 20, 20, srcdc, 360, 300, SRCCOPY );
	BitBlt( tempdc, 756, 2, 20, 20, srcdc, 380, 300, SRCCOPY );


	DeleteDC( srcdc );


} // end drawbuttonsonbg




int saveuserboards( void )
{
	HANDLE fh;


	fh = CreateFile( "Data//userboards.dat",           // create MYFILE.TXT 
            GENERIC_WRITE,                // open for writing 
            0,                            // do not share 
            NULL,                         // no security 
            CREATE_ALWAYS,                // overwrite existing 
            FILE_ATTRIBUTE_NORMAL |       // normal file 
            FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
            NULL );                        // no attr. template 

	if( fh == INVALID_HANDLE_VALUE ) return FALSE;

	if( !WriteFile( fh, userboard, 10L*100L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}

	if( !WriteFile( fh, userboardtype, 10L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}

	CloseHandle( fh );

	return TRUE;

} // end saveuserboards




int loaduserboards( void )
{
	HANDLE fh;

	fh = CreateFile( "Data//userboards.dat",           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 

	if( fh == INVALID_HANDLE_VALUE ) return FALSE;

	if( !ReadFile( fh, userboard, 10L * 100L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}
	if( !ReadFile( fh, userboardtype, 10L, &numofbytesread, NULL ) )
	{
		CloseHandle( fh );
		return FALSE;
	}
	
	CloseHandle( fh );

	return TRUE;	

} // end loaduserboards




// Returns TRUE if cannot find any more matches ...
BOOL nomorematches( void )
{
	byte blockcolor[8];	// number of each block color left
	byte boardslot;		// 0-99


	ZeroMemory( blockcolor, 8 );

	for( boardslot = 0; boardslot < 100; boardslot++ )
	{
		if( board[boardslot] )
		{
			blockcolor[ board[boardslot]-1 ]++;
		} // end if block here

	} // end count all blocks


/*	sprintf( tempstr, "%d %d %d %d %d %d %d %d", blockcolor[0], blockcolor[1], blockcolor[2], blockcolor[3], blockcolor[4], blockcolor[5], blockcolor[6], blockcolor[7] );
	MessageBox( hwndmain, tempstr, "blox found", MB_OK );
*/

	// Now using boardslot as the block color
	switch( gametype )
	{
	case BUMPIT:
		for( boardslot = 0; boardslot < 8; boardslot++ )
		{
			if( blockcolor[boardslot] >= 2 ) return FALSE;
		}

		break;

	case BUMPIT3:
		for( boardslot = 0; boardslot < 8; boardslot++ )
		{
			if( blockcolor[boardslot] >= 3 ) return FALSE;
		}

		break;

	case BUMPIT4:
		for( boardslot = 0; boardslot < 8; boardslot++ )
		{
			if( blockcolor[boardslot] >= 4 ) return FALSE;
		}

		break;

	case PUZZLE:
		for( boardslot = 0; boardslot < 8; boardslot++ )
		{
			if( blockcolor[boardslot] >= puzzletype[level] ) return FALSE;
		}

		break;

	case USERPLAY:
		for( boardslot = 0; boardslot < 8; boardslot++ )
		{
			if( blockcolor[boardslot] >= userboardtype[level] ) return FALSE;
		}

		break;

	case USEREDIT:
		return FALSE;

	} // end switch on gametype


	return TRUE;

} // end nomorematches