/*
message.cpp
message handler ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "globals.h"


#include <windows.h>
#include <shlwapi.h>





long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
			    WPARAM wParam, LPARAM lParam )
{
//	int index;
	byte ctrlkeydown = 0;
	int width, height;


// This handles ALL messages that come through no matter which part of the game the player is in ...

	switch( message )
    {
	case WM_PAINT:
		displayscreen();
		break;



// I'm gonna try to use this to know when i can restore my surfaces ...	
// TESTES!! Must change this! What if the user is already set at the same resolution as the game??!?!?
	case WM_DISPLAYCHANGE:
		screendc = GetDC( NULL );
	
	// Check for required screen resolution (800x600x16) ...
		if( (GetSystemMetrics( SM_CXSCREEN ) < 800 ) || (GetSystemMetrics( SM_CYSCREEN ) < 600) ||
			(GetDeviceCaps( screendc, BITSPIXEL ) < 15) )
		{
			ReleaseDC( NULL, screendc );
			
			switch( MessageBox( hwndmain, "Your monitor must be set to a resolution of at least 800 x 600 with 16 bits of color depth to play MatchBlox.\n\nWould you like instructions on how to do this now?", "Screen Resolution too low ...",
				MB_ICONEXCLAMATION|MB_YESNO|MB_TOPMOST ) )
			{
			default:
			case IDNO:
				cleanup( OK, NULL );
	
			case IDYES:
				ShellExecute( hwndmain, "open", "Help\\ChangeRes.htm", NULL, NULL, SW_SHOWNORMAL );
				cleanup( OK, NULL );
	
			} // end switch on response
	
		} // end if not enough

		ReleaseDC( NULL, screendc );

		break;

	case WM_SIZE:
		width = LOWORD(lParam);
		height = HIWORD(lParam);

//		sprintf( debugstr, "WM_SIZE: (%d, %d)\n", width, height );
//		WRITETODEBUGFILE;

// Set screen offsets ...
		screenoffsetx = (GetSystemMetrics( SM_CXSCREEN ) - VSCREENWIDTH) / 2;
		screenoffsety = (GetSystemMetrics( SM_CYSCREEN ) - VSCREENHEIGHT) / 2;


		if( !IsIconic( hwndmain ) )
		{
			RECT windowrect;
	
	
			windowrect.left = 0;
			windowrect.top = 0;
			windowrect.right = GetSystemMetrics( SM_CXSCREEN );
			windowrect.bottom = GetSystemMetrics( SM_CYSCREEN );

/*
			// Move ad window!
			if( adson )
			{
				if( (adx != (windowrect.right / 2) - (483/2)) &&
					(ady != (windowrect.bottom - 60)) )
				{
					sprintf( debugstr, "Moving Ad Window ...\n" );
					WRITETODEBUGFILE;
	
					Cydoor.ServiceClose( 0, hwndmain );
					
					adx = (windowrect.right / 2) - (483/2);
					ady = windowrect.bottom - 60;
					
					Cydoor.ServiceShow( 177, 1, 0, hwndmain, adx, ady, 483, 60, NULL, NULL, NULL );
				}
			}
*/
		
			AdjustWindowRect( &windowrect, WS_VISIBLE|WS_POPUP|WS_SYSMENU, FALSE );
		
			width = windowrect.right - windowrect.left;
			height = windowrect.bottom - windowrect.top;
	
			SetWindowPos( hwndmain, NULL, windowrect.left, windowrect.top, width, height,
				SWP_NOZORDER | SWP_NOACTIVATE );
	


			fullclient = TRUE;
			SetWindowPos( hwndmain, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE );
			SetForegroundWindow( hwndmain );
		}
		else
		{
			fullclient = FALSE;
		}

/*
		if( (width == GetSystemMetrics( SM_CXSCREEN )) && (height == GetSystemMetrics( SM_CYSCREEN )) )
		{
			fullclient = TRUE;
			SetWindowPos( hwndmain, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE );
			SetForegroundWindow( hwndmain );
		}
		else
		{
			fullclient = FALSE;
		}

*/		break;


/*
	case WM_ACTIVATE:
		switch( LOWORD(wParam) )
		{
		case WA_ACTIVE:
		case WA_CLICKACTIVE:
			bActive = 1;
//			SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );
			fullscreen = 1;
			break;

		case WA_INACTIVE:
			bActive = 0;
			fullscreen = 0;
//			SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );
			break;

		} // end switch on activate on disactivate

		break;
*/

// Is this still needed ?
// TODO -- Make Sure I refresh the screen here ...
    case WM_ACTIVATEAPP:
    	bActive = wParam;

		if( bActive && fullscreen && hwndmain )
		{
			SetWindowPos( hwndmain, HWND_TOPMOST, 0, 0, NULL, NULL, SWP_NOSIZE );
			SetForegroundWindow( hwndmain );
//			restoreAll();
			refreshscreen();
		} // end if need to restore surfaces
		else
		{
//			if( fullclient ) CloseWindow( hwndmain );
		}
		break;



    case WM_SETCURSOR:
        SetCursor( hcursor[currentcursor] );
		return TRUE;


    case WM_CREATE:
		break;



/*	case WM_KILLFOCUS:
		if( IsWindow(hwndmain) ) CloseWindow( hwndmain );
		break;
*/
		
/*	case WM_DDE_INITIATE:
		CloseWindow( hwndmain );
		break;
*/

    case WM_KEYDOWN:
		switch( wParam )
		{
			case VK_F11:
				fpson ^= 1;
				break;
		}

		break;

/*
// Message sent by AdWindow when WM_MOUSEACTIVATE received
	case WM_USER:
		CloseWindow( hwndmain );
		break;
*/

/*    case WM_KEYDOWN:
// Determine if ctrlkeydown ... I use this to keep a WM_KEYDOWN message being sent to the gamescreen handlers
// if it is down ...
		if( GetKeyState(VK_CONTROL)&0xFF00 ) ctrlkeydown = 1;

		switch( wParam )
		{
//			case VK_ESCAPE:
//				PostMessage(hWnd, WM_CLOSE, 0, 0);
//				break;
			case VK_F1:
				if( !ctrlkeydown ) break;
				switch( languageoffset )
				{
				case ENGLISH:
					languageoffset = GERMAN; break;
				case GERMAN:
					languageoffset = ENGLISH; break;
//				case SPANISH:
//					languageoffset = FRENCH; break;
//				case FRENCH:
//					languageoffset = ENGLISH; break;
				} // end switch on current language;

				refreshscreen();
				break;


#ifdef DEBUG
			case 'R':
				if( !ctrlkeydown ) break;
				refreshscreen();
				break;

#endif



		} // end switch on key

		break;

*/

	case WM_MOUSEMOVE:
		LPPOINT lpPoint;	// For retrieving cursor position ...
		POINT point;

		lpPoint = &point;


		GetCursorPos( lpPoint );

		cursorx = lpPoint->x - screenoffsetx;
		cursory = lpPoint->y - screenoffsety;

		break;


	case WM_LBUTTONDOWN:
		lmb = 1;
		break;
	case WM_RBUTTONDOWN:
		rmb = 1;
		break;
	case WM_LBUTTONUP:
		lmb = 0;
		break;
	case WM_RBUTTONUP:
		rmb = 0;
		break;



    case WM_DESTROY:
		SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );

		if( timeKillEvent(clockid) == MMSYSERR_INVALPARAM )
		{
			sprintf( tempstr, "clockid = %d", clockid );
			MessageBox( hwndmain, tempstr, "Could Not Kill Timer!", MB_OK );
		} // end if Kill timer failed


		finiObjects();
		PostQuitMessage( 0 );
//		CloseHandle( debugfh );

		break;

    } // end switch on Windows Message

// Now dispatch the message out to the appropriate game screen if it is NOT a CTRL key combination ...

// If control key is pressed, do NOT send WM_KEYDOWN through to appropriate game screen handler!
	if( (message == WM_KEYDOWN) && ctrlkeydown )
	 return DefWindowProc(hWnd, message, wParam, lParam);


	switch( gamescreen )
	{
	case GS_MAINMENU:
		mainmenumessagehandler( message, wParam, lParam );
		break;
	case GS_OKBOX:
		okboxmessagehandler( message, wParam, lParam );
		break;
	case GS_CONFIRM:
		confirmmessagehandler( message, wParam, lParam );
		break;
	case GS_SELECTLIST:
		selectlistmessagehandler( message, wParam, lParam );
		break;

	case GS_PLAY:
		playmessagehandler( message, wParam, lParam );
		break;
	case GS_ARRANGEPUZZLES:
		arrangepuzzlesmessagehandler( message, wParam, lParam );
		break;
	
	} // end switch on gamescreen
	

    return DefWindowProc(hWnd, message, wParam, lParam);

} // end WindowProc



int mainmenumessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int index;
//	int buttonno;


	switch( message )
	{
	case WM_ERASEBKGND:
/*		screendc = GetDC( hwndmain );

		BitBlt( screendc, 0, 0, SCREENWIDTH + (screenoffsetx<<1), SCREENHEIGHT + (screenoffsety<<1),
			tempdc, 0, 0, BLACKNESS );

		ReleaseDC( hwndmain, screendc );
*/
		InvalidateRect( hwndmain, NULL, FALSE );
		return TRUE;


	case WM_ACTIVATEAPP:
		showgametypes();
		showhiscores();
		showquitbutton();

		InvalidateRect( hwndmain, NULL, FALSE );
		break;


	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			cleanup( OK, NULL );
			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN


	case WM_LBUTTONDOWN:
		switch( isoverbutton )
		{
			default:
			case 0:
				break;

			case 1:
				CLICK;
				gametype = BUMPIT;
				playgame();
				intro();
				showgametypes();
				showhiscores();
				break;	// MATCH 2

			case 2:
				CLICK;
				gametype = BUMPIT3;
				playgame();
				intro();
				showgametypes();
				showhiscores();
				break;	// MATCH 3

			case 3:
				CLICK;
				gametype = BUMPIT4;
				playgame();
				intro();
				showgametypes();
				showhiscores();
				break;	// MATCH 4

			case 4:
				CLICK;
				gametype = PUZZLE;
				playgame();
				intro();
				showgametypes();
				showhiscores();
				break;	// PUZZLES

			case 5:
				CLICK;
				CloseWindow( hwndmain );
				ShellExecute( hwndmain, "open", "http://www.nspgames.com", NULL, NULL, 0 );
				break;	// NSP LOGO

			case 6:
				CLICK;
				CloseWindow( hwndmain );
				ShellExecute( hwndmain, "open", "http://www.netstorm.org", NULL, NULL, 0 );
				break;	// Cydoor LOGO

			case 7:
				CLICK;
				gametype = USEREDIT;
				playgame();
				intro();
				showgametypes();
				showhiscores();
				break;	// Board Editor

			case 8:
				CLICK;
				ShellExecute( hwndmain, "open", "Help\\MatchBlox.htm", NULL, NULL, SW_SHOWNORMAL );
				CloseWindow( hwndmain );
				break;	// Help

			case 9:
				CLICK;

				currentcursor = 0;
				SetCursor( hcursor[currentcursor] );
				
				if( MessageBox( hwndmain, "Are you sure you want to erase the High Scores?", "Confirm Reset ...",
					MB_YESNO|MB_TOPMOST|MB_ICONEXCLAMATION ) == IDYES )
				{
					strcpy( hiscorename[0], "Anonymous" );
					strcpy( hiscorename[1], "Anonymous" );
					strcpy( hiscorename[2], "Anonymous" );
					strcpy( hiscorename[3], "Anonymous" );
				
					hiscore[0] = 0;
					hiscore[1] = 0;
					hiscore[2] = 0;
					hiscore[3] = 0;
				
					// Save hi score file here ...
					sprintf( debugstr, "Saving Game high scores ...\n\n" );
					WRITETODEBUGFILE;
				
					HANDLE hiscorefh = CreateFile("data\\hiscores.dat",           // create MYFILE.TXT 
					            GENERIC_WRITE,                // open for writing 
							    0,                            // do not share 
								NULL,                         // no security 
								CREATE_ALWAYS,                // overwrite existing 
								FILE_ATTRIBUTE_NORMAL |       // normal file 
								FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
								NULL);                        // no attr. template 
				
					if( hiscorefh == INVALID_HANDLE_VALUE ) cleanup( NOFILE, "data\\hiscores.dat" );
				
					if( !WriteFile( hiscorefh, hiscorename, 24*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );
					if( !WriteFile( hiscorefh, hiscore, sizeof(int)*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );
				
					CloseHandle( hiscorefh );
	
					clearscreen();
					refreshscreen();
	
				} // end if resetting high scores
	
				break;	// Reset

			case 10:
				CLICK;
				cleanup( OK, NULL );

			case 11:
				CLICK;
				CloseWindow( hwndmain );
				break;	// Minimize

		} // end switch on isoverbutton

		break;	// end case WM_LBUTTONDOWN


	case WM_MOUSEMOVE:
		checkmenucursor();
		break;	// end case WM_MOUSEMOVE

	} // end switch on Windows Messages for GS_MAINMENU

	return TRUE;
} // end mainmenumessagehandler



int okboxmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int buttonno;


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_RETURN:
		case VK_ESCAPE:
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = TRUE;

			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN



	case WM_LBUTTONDOWN:
		if( (cursorx>button[0].x1) && (cursorx<button[0].x1+button[0].width) &&
			(cursory>button[0].y1) && (cursory<button[0].y1+24) )
		{
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = TRUE;

			break;
		} // end if pressed on "Ok" button

		break;

	case WM_MOUSEMOVE:
		for( buttonno = 0; buttonno < 1; buttonno++ )
		{
			if( (cursorx>button[buttonno].x1) && (cursorx<button[buttonno].x1+button[buttonno].width) &&
				(cursory>button[buttonno].y1) && (cursory<button[buttonno].y1+24) )
			{
				button[buttonno].glowing = 1;
			} // end if cursor on top of button
			else button[buttonno].glowing = 0;

			drawbutton( buttonno );
		} // end buttonno loop
		break; // end WM_MOUSEMOVE

	} // end switch on Windows Messages for GS_OKBOX


	return TRUE;

} // end okboxmessagehandler



int confirmmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int buttonno;


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_RETURN:
		case VK_ESCAPE:
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

			break;

		case 'Y':
			button[1].pushed = 1;
			drawbutton( 1 );
			displayscreen();

			g_response = TRUE;

			break;

		case 'N':
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN

	case WM_LBUTTONDOWN:
		if( (cursorx>button[0].x1) && (cursorx<button[0].x1+button[0].width) &&
			(cursory>button[0].y1) && (cursory<button[0].y1+24) )
		{
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

			break;
		} // end if pressed on "No" button

		if( (cursorx>button[1].x1) && (cursorx<button[1].x1+button[1].width) &&
			(cursory>button[1].y1) && (cursory<button[1].y1+24) )
		{
			button[1].pushed = 1;
			drawbutton( 1 );
			displayscreen();

			g_response = TRUE;

			break;
		} // end if pressed on "No" button

		break;

	case WM_MOUSEMOVE:
		for( buttonno = 0; buttonno < 2; buttonno++ )
		{
			if( (cursorx>button[buttonno].x1) && (cursorx<button[buttonno].x1+button[buttonno].width) &&
				(cursory>button[buttonno].y1) && (cursory<button[buttonno].y1+24) )
			{
				button[buttonno].glowing = 1;
			} // end if cursor on top of button
			else button[buttonno].glowing = 0;

			drawbutton( buttonno );
		} // end buttonno loop
		break; // end WM_MOUSEMOVE

	} // end switch on Windows Messages for GS_CONFIRM


	return TRUE;

} // end confirmmessagehandler



int waitmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{

	switch( message )
	{
	case WM_KEYDOWN:
		g_response = TRUE;

		break; // end WM_KEYDOWN

	case WM_RBUTTONDOWN:	
	case WM_LBUTTONDOWN:
		g_response = TRUE;
		break;

	} // end switch on Windows Messages for GS_WAITFORINPUT


	return TRUE;

} // end waitmessagehandler








// Called after gamescreen changes, or to refresh the screen user is on ...
BOOL refreshscreen( void )
{

	clearscreen();

	switch( gamescreen )
	{
	case GS_PLAY:
		drawbuttonsonbg();
		drawboard( 0 );
		break;


	case GS_MAINMENU:
		SelectObject( tempdc, hbmp[DDS_SLIDERS] );
		BitBlt( memdc, 200, 30, 400, 100, tempdc, 0, 0, SRCCOPY );

		SelectObject( nagdc, hbmp[DDS_COPYRIGHT] );
		BitBlt( memdc, (SCREENWIDTH/2)-128, 112, 256, 16, nagdc, 0, 0, SRCCOPY );

		break;	// end GS_MAINMENU


	case GS_SELECTLIST:
		int listheight;
		int tempx, tempy;

		listheight = numoptions * 14;
		tempx = listboxx+4;
		tempy = listboxy+2;

		textinbounds = 0;
/*
		LOCKVS;

		tempscreenptr = g_vsptr + VSOFFSET + listboxx + times768(listboxy);

		for( optionno = 0; optionno < numoptions; optionno++ )
		{
			if( optionno == selectedoption-1 ) // Convert to 1-? instead of 0-?
			{
				for( lineindex = 0; lineindex < 14; lineindex++ )
				{
					memset( tempscreenptr, 2, listwidth );
					tempscreenptr += VSCREENWIDTH;
				} // end lineindex loop

//				SETTEXTCOLOR(31,31,31);
				showtext( selectoption[optionno].text, tempx, tempy );
			} // end if drawing selectedoption
			else
			{
				for( lineindex = 0; lineindex < 14; lineindex++ )
				{
					memset( tempscreenptr, 1, listwidth );
					tempscreenptr += VSCREENWIDTH;
				} // end lineindex loop

//				if( selectoption[optionno].disabled ) SETTEXTCOLOR(12,12,12)
//				else SETTEXTCOLOR(0,24,0);

				showtext( selectoption[optionno].text, tempx, tempy );
			} // end if NOT selectedoption

			tempy += 14;

		} // end optionno loop

		UNLOCKVS;

*/		textinbounds = 1;

		break; // end GS_SELECTLIST

	} // end switch on gamescreen


	return TRUE;
} // end refreshscreen



int startgamescreen( byte gs )
{


	pushgamescreen( gamescreen );
	gamescreen = gs;

	switch( gamescreen )
	{
	case GS_MAINMENU:
		break;
	} // end switch on gamescreen


	refreshscreen();


	return TRUE;

} // end startgamescreen





int playmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int boardx, boardy, boardspace;
	int boardcolor;
	int index;
	int loopall;
	int loopcount;
	BOOL counting;

	int homex, homey;	// Used when board won
	int blockspace;


	switch( message )
	{
	case WM_ERASEBKGND:
/*		screendc = GetDC( hwndmain );

		BitBlt( screendc, 0, 0, SCREENWIDTH + (screenoffsetx<<1), SCREENHEIGHT + (screenoffsety<<1),
			tempdc, 0, 0, BLACKNESS );

		ReleaseDC( hwndmain, screendc );
*/
		InvalidateRect( hwndmain, NULL, FALSE );
		return TRUE;


	case WM_PAINT:
		displayscreen();
		break;

	case WM_CHAR:	// for cheat code
		if( gametype != PUZZLE ) break;

		if( (char)wParam != cheatcode[cheatcodeletter] )
		{
			cheatcodeletter = 0;
			break;
		} // end if wrong key pressed ... start over

		cheatcodeletter++;

		if( cheatcodeletter == 11 )
		{
			cheatcodeletter = 0;
			score = 0;

			ZeroMemory( board, 100 );
			goto WinGame;
		} // end if typed in cheat code

		break;


	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			g_response = TRUE;
			break;

/*
// TODO: Editors ONLY!
		case VK_F9:
			arrangepuzzles();
			break;
		case VK_F2:
			puzzletype[level] = 2;
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			break;
		case VK_F3:
			puzzletype[level] = 3;
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			break;
		case VK_F4:
			puzzletype[level] = 4;
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			break;


		case VK_F6:
			loadpuzzles( "" );
			memcpy( board, puzzleboard[level], 100 );
			drawboard( 0 );
			displayscreen();
			break;

		case VK_F7:
			savepuzzles( "" );
			break;

		case VK_F8:
			int charnumber;

			charnumber = strlen(lastfilename);
			while( lastfilename[charnumber] != '\\' ) charnumber--;

			savepuzzles( lastfilename );
			sprintf( tempstr, "Puzzles saved as '%s'", lastfilename+charnumber+1 );
			mytextcolor = TEXTWHITE;
			centertext( tempstr, 300, 0, SCREENWIDTH );
			displayscreen();
			break;

		case 'C':
			ZeroMemory( board, 100 );
			drawboard( 0 );
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			break;

		case '0':	placeblock( 0 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '1':	placeblock( 1 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '2':	placeblock( 2 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '3':	placeblock( 3 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '4':	placeblock( 4 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '5':	placeblock( 5 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '6':	placeblock( 6 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '7':	placeblock( 7 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;
		case '8':	placeblock( 8 ); SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); break;



		case VK_RIGHT:
//			savepuzzles( "data\\puzzles.dat" );
			level++;
			memcpy( board, puzzleboard[level], 100 );
			drawboard( 0 );
			displayscreen();
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); 
			break;
		case VK_LEFT:
//			savepuzzles( "data\\puzzles.dat" );
			level--;
			if( level == -1 ) level = 0;
			memcpy( board, puzzleboard[level], 100 );
			drawboard( 0 );
			displayscreen();
			SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); 
			break;
*/
		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN



	case WM_LBUTTONDOWN:
// Quit Button ...
		if( (cursorx > 778) && (cursorx < 798) && (cursory > 2) && (cursory < 22) )
		{
			CLICK;

			if( gametype == PUZZLE )
			{
				if( score > hiscore[PUZZLE] ) dopuzzlehiscore();
			} // end if puzzle game

			if( gametype == USEREDIT )
			{
				memcpy( userboard[level], board, 100 );	// Save board
			} // end if need to save current board

			cleanup( OK, NULL );
			break;
		} // end Quit button

// Minimize Button ...
		if( (cursorx > 756) && (cursorx < 776) && (cursory > 2) && (cursory < 22) )
		{
			CLICK;
			CloseWindow( hwndmain );
			break;
		} // end minimize button

// PASSWORD button ...
		if( gametype == PUZZLE )
		{
		if( (cursorx > 25) && (cursorx < 145) && (cursory > 304) && (cursory < 336) )
		{
			CLICK;

			if( score > hiscore[PUZZLE] ) dopuzzlehiscore();
			score = 0;

			enterpassword();

			ShowCursor( FALSE );

			memcpy( board, puzzleboard[level], 100 );
// Fade in ...
			memset( flagdelete, 1, 100 );
			for( index = 7; index > 0; index-- )
			{
				newtickcount = tickcount + 3;

				drawboard( index );
				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end index loop
			memset( flagdelete, 0, 100 );
			drawboard( 0 );

			ShowCursor( TRUE );

			break;
		} // end if over BACK button
		} // end if playing PUZZLES


// BACK button ...
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 304) && (cursory < 336) )
		{
			CLICK;
			waitfor(3);

			if( gametype == PUZZLE )
			{
				if( score > hiscore[PUZZLE] ) dopuzzlehiscore();
			}

			if( gametype == USEREDIT )
			{
				memcpy( userboard[level], board, 100 );	// Save board
				saveuserboards();
			} // end save user boards

			g_response = TRUE;
			break;
		} // end if over BACK button

// New Game ...
		if( (cursorx > 655) && (cursorx < 775) && (cursory > 264) && (cursory < 296) )
		{
			CLICK;

			if( gametype == PUZZLE )
			{
				if( score > hiscore[PUZZLE] ) dopuzzlehiscore();
			} // end recopy puzzle


// Fade out ...
			ShowCursor( FALSE );

			memset( flagdelete, 1, 100 );
			for( index = 0; index < 8; index++ )
			{
				newtickcount = tickcount + 3;

				drawboard( index );
				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end index loop
			memset( flagdelete, 0, 100 );

			score = 0;

			switch( gametype )
			{
			case PUZZLE:
				memcpy( board, puzzleboard[level], 100 );
				break;

			default:
				for( blockspace = 0; blockspace < 100; blockspace++ )
				{
					*(board + blockspace) = rand()%9;
				} // end fill board randomly
				break;

			case USEREDIT:
				ZeroMemory( board, 100 );
				break;

			case USERPLAY:
				memcpy( board, userboard[level], 100 );
				break;

			} // end switch on gametype

// Fade in ...
			memset( flagdelete, 1, 100 );
			for( index = 7; index > 0; index-- )
			{
				newtickcount = tickcount + 3;

				drawboard( index );
				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end index loop
			memset( flagdelete, 0, 100 );


// Count tiles ...
			numoftiles = 0;
			for( index = 0; index < 100; index++ )
			{
				if( board[index] ) numoftiles++;
			} // end index loop


			drawbg();
//			drawcharacter( characternumber, 40, 240, NORMAL );
			drawboard( 0 );
			drawscore();
			displayscreen();

			ShowCursor( TRUE );

			firsttime = TRUE;
			checkboard();
			firsttime = FALSE;
			
			break;
		} // end New Game button


// Editor buttons
	if( (gametype == USEREDIT) || (gametype == USERPLAY) )
	{
		if( (cursorx > 25) && (cursorx < 145) )
		{
			if( (cursory > 100) && (cursory < 132) )
			{
				if( gametype != USEREDIT )
				{
					CLICK;
					memcpy( board, userboard[level], 100 );	// Load board

					gametype = USEREDIT;
					drawbuttonsonbg();

					SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
				} // end switch to USEREDIT

			} // end edit button

			if( (cursory > 140) && (cursory < 172) )
			{
				if( gametype != USERPLAY )
				{
					CLICK;
					memcpy( userboard[level], board, 100 );	// Save board

					// Make sure board is NOT full!
					int boardcount = 0;

					for( int index = 0; index < 100; index++ )
					{
						if( board[index] ) boardcount++;
					}

					if( boardcount == 100 )
					{
						SetCursor( hcursor[0] );
						currentcursor = 0;
						MessageBox( hwndmain, "You must have at least one empty space on the board to play.",
							"Board Full!", MB_OK|MB_TOPMOST|MB_ICONEXCLAMATION );
						break;
					} // end if board full

					gametype = USERPLAY;	// must change this so nomorematches actually checks ...
					if( nomorematches() )
					{
						SetCursor( hcursor[0] );
						currentcursor = 0;
						MessageBox( hwndmain, "You must have enough blox for at least one match to play ...",
							"No Possible Matches!", MB_OK|MB_TOPMOST|MB_ICONEXCLAMATION );
						gametype = USEREDIT;	// return to original state
						break;
					} // end check for no matches

					score = 0;
					drawbuttonsonbg();

					firsttime = TRUE;
					checkboard();
					firsttime = FALSE;

					SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
				} // end switch to USEREDIT

			} // end play button

			if( (cursory > 320) && (cursory < 352) )
			{
				CLICK;
				if( gametype == USEREDIT )
					memcpy( userboard[level], board, 100 );	// Save board

				score = 0;

				if( level > 0 ) level--;
				memcpy( board, userboard[level], 100 );	// Load board
				drawboard( 0 );

				firsttime = TRUE;
				checkboard();
				firsttime = FALSE;

				SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			} // end prev button

			if( (cursory > 360) && (cursory < 392) )
			{
				CLICK;
				if( gametype == USEREDIT )
					memcpy( userboard[level], board, 100 );	// Save board

				score = 0;

				if( level < 9 ) level++;
				memcpy( board, userboard[level], 100 );	// Load board
				drawboard( 0 );

				firsttime = TRUE;
				checkboard();
				firsttime = FALSE;

				SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen
			} // end next button

		} // end if in x range

	} // end editor buttons


// Game specific clicks ...
	switch( gametype )
	{
	case BUMPIT:
	case BUMPIT3:
	case BUMPIT4:
	case PUSHIT:
	case PUZZLE:
	case USERPLAY:
// Top Row ...		
		if( (cursorx > 200) && (cursorx < 600) && (cursory > 70) && (cursory < 100) )
		{
			CLICK;
			waitfor(3);

			boardx = (cursorx-200) / 40;

// Determine loopcount (number of times to loop through slide) ...
			loopcount = 0;
			counting = 0;

			for( boardy = 9; boardy >= 0; boardy-- )
			{
				boardspace = (boardy<<3)+(boardy<<1) + boardx;

				if( board[boardspace] )
				{
					counting = 1;
					continue;
				} // end if piece here ...

				if( counting ) loopcount++;

			} // end boardy loop


// Testes ... Slide ALL ...
//			ShowCursor( FALSE );

			for( loopall = 0; loopall < loopcount; loopall++ )
			{
				newtickcount = tickcount + 3;

				for( boardy = 0; boardy < 10; boardy++ )
				{
					boardspace = (boardy<<3)+(boardy<<1) + boardx;
					if( board[boardspace] == 0 ) break;
				} // end index loop

				if( boardy == 10 ) break;	// No empty spaces
				if( boardy == 9 ) break;	// Last space empty

				for( index = boardy; index < 9; index++ )
				{
					boardspace = (index<<3)+(index<<1) + boardx;
					board[boardspace] = board[boardspace + 10];
				} // end index loop

				board[90 + boardx] = 0; // clear last one

				drawboard( 0 );
// TODO: OPT!
				switch( loopall % 4 )
				{
				case 0:		CLICK1;	break;
				case 1:		CLICK2;	break;
				case 2:		CLICK3;	break;
				case 3:		CLICK4;	break;
				}

				displayscreen();

				while( tickcount < newtickcount ) {};

			} // end loop all

//			ShowCursor( TRUE );

			goto EndCheck;

		} // end if click on top row


// Bottom Row ...		
		if( (cursorx > 200) && (cursorx < 600) && (cursory > 500) && (cursory < 530) )
		{
			CLICK;
			waitfor(3);

			boardx = (cursorx-200) / 40;

// Determine loopcount (number of times to loop through slide) ...
			loopcount = 0;
			counting = 0;

			for( boardy = 0; boardy < 10; boardy++ )
			{
				boardspace = (boardy<<3)+(boardy<<1) + boardx;

				if( board[boardspace] )
				{
					counting = 1;
					continue;
				} // end if piece here ...

				if( counting ) loopcount++;

			} // end boardy loop


// Testes ... Slide ALL ...
//			ShowCursor( FALSE );

			for( loopall = 0; loopall < loopcount; loopall++ )
			{
				newtickcount = tickcount + 3;

				for( boardy = 9; boardy >= 0; boardy-- )
				{
					boardspace = (boardy<<3)+(boardy<<1) + boardx;
					if( board[boardspace] == 0 ) break;
				} // end index loop

				if( boardy == -1 ) break;	// No empty spaces
				if( boardy == 0 ) break;	// Last space empty

				for( index = boardy; index > 0; index-- )
				{
					boardspace = (index<<3)+(index<<1) + boardx;
					board[boardspace] = board[boardspace - 10];
				} // end index loop

				board[boardx] = 0; // clear last one

				drawboard( 0 );
// TODO: OPT!
				switch( loopall % 4 )
				{
				case 0:		CLICK1;	break;
				case 1:		CLICK2;	break;
				case 2:		CLICK3;	break;
				case 3:		CLICK4;	break;
				}

				displayscreen();

				while( tickcount < newtickcount ) {};

			} // end loop all

//			ShowCursor( TRUE );

			goto EndCheck;

		} // end if click on bottom row


// Left Side ...		
		if( (cursorx > 170) && (cursorx < 200) && (cursory > 100) && (cursory < 500) )
		{
			CLICK;
			waitfor(3);

			boardy = (cursory-100) / 40;

// Determine loopcount (number of times to loop through slide) ...
			loopcount = 0;
			counting = 0;

			for( boardx = 9; boardx >= 0; boardx-- )
			{
				boardspace = (boardy<<3)+(boardy<<1) + boardx;

				if( board[boardspace] )
				{
					counting = 1;
					continue;
				} // end if piece here ...

				if( counting ) loopcount++;

			} // end boardx loop


// Testes ... Slide ALL ...
//			ShowCursor( FALSE );

			for( loopall = 0; loopall < loopcount; loopall++ )
			{
				newtickcount = tickcount + 3;

				for( boardx = 0; boardx < 10; boardx++ )
				{
					boardspace = (boardy<<3)+(boardy<<1) + boardx;
					if( board[boardspace] == 0 ) break;
				} // end index loop

				if( boardx == 10 ) break;	// No empty spaces
				if( boardx == 9 ) break;	// Last space empty

				for( index = boardx; index < 9; index++ )
				{
					boardspace = (boardy<<3)+(boardy<<1) + index;
					board[boardspace] = board[boardspace+1];
				} // end index loop

				board[(boardy<<3)+(boardy<<1) + 9] = 0; // clear last one

				drawboard( 0 );
// TODO: OPT!
				switch( loopall % 4 )
				{
				case 0:		CLICK1;	break;
				case 1:		CLICK2;	break;
				case 2:		CLICK3;	break;
				case 3:		CLICK4;	break;
				}

				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end loop all

//			ShowCursor( TRUE );

			goto EndCheck;

		} // end if click on left side


// Right Side ...		
		if( (cursorx > 600) && (cursorx < 630) && (cursory > 100) && (cursory < 500) )
		{
			CLICK;
			waitfor(3);

			boardy = (cursory-100) / 40;

// Determine loopcount (number of times to loop through slide) ...
			loopcount = 0;
			counting = 0;

			for( boardx = 0; boardx < 10; boardx++ )
			{
				boardspace = (boardy<<3)+(boardy<<1) + boardx;

				if( board[boardspace] )
				{
					counting = 1;
					continue;
				} // end if piece here ...

				if( counting ) loopcount++;

			} // end boardx loop


// Testes ... Slide ALL ...
//			ShowCursor( FALSE );

			for( loopall = 0; loopall < loopcount; loopall++ )
			{
				newtickcount = tickcount + 3;

				for( boardx = 9; boardx >= 0; boardx-- )
				{
					boardspace = (boardy<<3)+(boardy<<1) + boardx;
					if( board[boardspace] == 0 ) break;
				} // end index loop

				if( boardx == -1 ) break;	// No empty spaces
				if( boardx == 0 ) break;	// Last space empty

				for( index = boardx; index > 0; index-- )
				{
					boardspace = (boardy<<3)+(boardy<<1) + index;
					board[boardspace] = board[boardspace-1];
				} // end index loop

				board[(boardy<<3)+(boardy<<1)] = 0; // clear last one

				drawboard( 0 );
// TODO: OPT!
				switch( loopall % 4 )
				{
				case 0:		CLICK1;	break;
				case 1:		CLICK2;	break;
				case 2:		CLICK3;	break;
				case 3:		CLICK4;	break;
				}

				displayscreen();

				while( tickcount < newtickcount ) {};
			} // end loop all

//			ShowCursor( TRUE );

			goto EndCheck;

		} // end if click on right side

		break; // end case BUMPIT


	case USEREDIT:
		if( (cursorx > 240) && (cursorx < 560) && (cursory > 20) && (cursory < 60) )
		{
			CLICK;
			currtile = ((cursorx - 240) / 40) + 1;

			drawscore();
			InvalidateRect( hwndmain, NULL, FALSE );
		} // end select tile

		if( (cursorx > 200) && (cursorx < 600) && (cursory > 100) && (cursory < 500) )
		{
			CLICK;

			boardx = (cursorx-200) / 40;
			boardy = (cursory-100) / 40;
			boardspace = (boardy<<3)+(boardy<<1) + boardx;

			board[boardspace] = currtile;

			drawboard( 0 );

			InvalidateRect( hwndmain, NULL, FALSE );
		} // end if click on board

		if( (cursorx > 25) && (cursorx < 145) && (cursory > 278) && (cursory < 300) )
		{
			CLICK;

			userboardtype[level]++;
			if( userboardtype[level] == 5 ) userboardtype[level] = 2;

			drawbg();
			drawscore();
			drawbuttons();

			InvalidateRect( hwndmain, NULL, FALSE );
		} // end change gametype

		break;
	} // end switch on gametype
		



EndCheck:

		drawboard( 0 );
		displayscreen();

		switch( checkboard() )
		{
		default:
			break;

		case CHECKLOSE:

			SetCursor( hcursor[0] );
			currentcursor = 0;

			PLAYLOSEGAME;

			switch( MessageBox( hwndmain, "Would you like to restart now?", "No more matches!", MB_YESNO ) )
			{
			case IDYES:

// Fade out ...
				ShowCursor( FALSE );
	
				memset( flagdelete, 1, 100 );
				for( index = 0; index < 8; index++ )
				{
					newtickcount = tickcount + 3;
	
					drawboard( index );
					displayscreen();
	
					while( tickcount < newtickcount ) {};
				} // end index loop
				memset( flagdelete, 0, 100 );
	
				score = 0;
	
				switch( gametype )
				{
				case PUZZLE:
					memcpy( board, puzzleboard[level], 100 );
					break;
	
				default:
					for( blockspace = 0; blockspace < 100; blockspace++ )
					{
						*(board + blockspace) = rand()%9;
					} // end fill board randomly
					break;
	
				case USEREDIT:
					ZeroMemory( board, 100 );
					break;
	
				case USERPLAY:
					memcpy( board, userboard[level], 100 );
					break;
	
				} // end switch on gametype
	
	// Fade in ...
				memset( flagdelete, 1, 100 );
				for( index = 7; index > 0; index-- )
				{
					newtickcount = tickcount + 3;
	
					drawboard( index );
					displayscreen();
	
					while( tickcount < newtickcount ) {};
				} // end index loop
				memset( flagdelete, 0, 100 );
	
	
	// Count tiles ...
				numoftiles = 0;
				for( index = 0; index < 100; index++ )
				{
					if( board[index] ) numoftiles++;
				} // end index loop
	
	
				drawbg();
	//			drawcharacter( characternumber, 40, 240, NORMAL );
				drawboard( 0 );
				drawscore();
				displayscreen();
	
				ShowCursor( TRUE );
	
				firsttime = TRUE;
				checkboard();
				firsttime = FALSE;

				break;

			} // end switch on messagebox response

			break;

		case CHECKWIN:

WinGame:
			int wincount;
			HRESULT result;

			PLAYWINGAME;

			switch( gametype )
			{
			case PUZZLE:
				wincount = 1;
				// TODO: Max out level ...
				break;

			case USERPLAY:
				wincount = 1;
				break;

			case BUMPIT:	wincount = 1;	break;
			case BUMPIT3:	wincount = 2;	break;
			case BUMPIT4:	wincount = 3;	break;
			} // end switch on gametype

			ShowCursor( FALSE );

			for( int loop = 0; loop < wincount; loop++ )
			{
				homex = rand()%8;
				homey = rand()%8;

				for( index = 8; index > -13; index-- )
				{
					newtickcount = tickcount + 3;

					boardspace = 0;
	
					for( boardy = 0; boardy < 10; boardy++ )
					{
						for( boardx = 0; boardx < 10; boardx++ )
						{
							boardcolor = getdistance( boardx, boardy, homex, homey ) + index;
							if( (boardcolor < 0) || (boardcolor > 8) ) boardcolor = 0;
		
							board[boardspace] = boardcolor;
	
							boardspace++;
						} // end boardx loop
	
					} // end boardy loop
	
					drawboard( 0 );
					displayscreen();
	
					while( tickcount < newtickcount ) {};
				} // end index loop

			} // end loop wincount times

			ShowCursor( TRUE );

			// Check for max puzzle level ...
			if( gametype == PUZZLE )
			{
				if( level == 109 )
				{
					SetCursor( hcursor[0] );
					currentcursor = 0;

					MessageBox( hwndmain, "You've beaten all 110 levels!\n\nThanks for playing MatchBlox ...\n\nCheck out our web site at www.nspgames.com\nto download more free games from NSP Games!",
						"Congratulations!", MB_OK|MB_TOPMOST );

					g_response = TRUE;
					break;
				} // end if beat all levels ...


				highestlevelcompleted = level;
				level++;

				// Show password if needed ...
				if( (level) == (((level)/5)*5) ) showpassword();


				memcpy( board, puzzleboard[level], 100L );

// Fade in ...
				ShowCursor( FALSE );

				memset( flagdelete, 1, 100 );
				for( index = 7; index >= 0; index-- )
				{
					newtickcount = tickcount + 3;

					drawboard( index );
					displayscreen();

					while( tickcount < newtickcount ) {};
				} // end index loop
				memset( flagdelete, 0, 100 );

				ShowCursor( TRUE );

				break;	// hi score for puzzles saved on exit to menu or exit of game
			}

			if( gametype == USERPLAY )
			{
				break;
			} // end if USERPLAY
	
//			g_response = WINGAME;


// Look for new hi score ...
			if( score > hiscore[gametype] )
			{
				HANDLE hiscorefh;


				setcursormode( CURSOROFF );
				displayscreen();
				displayscreen();
//				lpDD7->FlipToGDISurface();
				result = DialogBox( hInst, "NEWHISCORE", hwndmain, hiscoredialogfunc );

				if( *lastknownname == NULL )
				{
					strcpy( lastknownname, "ANONYMOUS" );
				} // end if NOTHING entered

				strcpy( hiscorename[gametype], lastknownname );
				hiscore[gametype] = score;

				setcursormode( MENUCURSOR );

				g_response = TRUE;	// Return to high score screen afterwards
// Save hi score file here ...
sprintf( debugstr, "Saving Game high scores ...\n\n" );
WRITETODEBUGFILE;

				hiscorefh = CreateFile("data\\hiscores.dat",           // create MYFILE.TXT 
	             GENERIC_WRITE,                // open for writing 
			     0,                            // do not share 
				 NULL,                         // no security 
				CREATE_ALWAYS,                // overwrite existing 
				FILE_ATTRIBUTE_NORMAL |       // normal file 
				FILE_FLAG_RANDOM_ACCESS,         // asynchronous I/O 
				NULL);                        // no attr. template 

				if( hiscorefh == INVALID_HANDLE_VALUE ) cleanup( NOFILE, "data\\hiscores.dat" );

				if( !WriteFile( hiscorefh, hiscorename, 24*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );
				if( !WriteFile( hiscorefh, hiscore, sizeof(int)*4, &numofbytesread, NULL ) ) cleanup( NOFILE, "data\\hiscores.dat" );

				CloseHandle( hiscorefh );

				break;
	
			} // end if new high score

		} // end switch on checkboard

		SendMessage( hwndmain, WM_MOUSEMOVE, 0, 0 ); // to update screen

		break;



// TODO: Cheat Mode ONLY!

	case WM_RBUTTONDOWN:
		if( gametype != USEREDIT ) break;
		if( (cursorx < 200) || (cursorx > 600) || (cursory < 100) || (cursory > 500) )
			break; // Off board ...

		CLICK;

		boardy = (cursory - 100) / 40;
		boardx = (cursorx - 200) / 40;
		boardspace = (boardy<<3)+(boardy<<1) + boardx;

		board[boardspace] = 0;

		drawboard( 0 );
		InvalidateRect( hwndmain, NULL, FALSE );
		break; // end case WM_RBUTTONDOWN

/*
	case WM_RBUTTONDOWN:
		homex = 4;
		homey = 4;

		for( index = 8; index > -13; index-- )
		{
			boardspace = 0;

			for( boardy = 0; boardy < 10; boardy++ )
			{
				for( boardx = 0; boardx < 10; boardx++ )
				{
					boardcolor = getdistance( boardx, boardy, homex, homey ) + index;
					if( (boardcolor < 0) || (boardcolor > 8) ) boardcolor = 0;

					board[boardspace] = boardcolor;

					boardspace++;
				} // end boardx loop

			} // end boardy loop

			drawboard( 0 );
			displayscreen();

		} // end index loop


		g_response = TRUE;
		break;
*/

	case WM_ACTIVATEAPP:
	case WM_MOUSEMOVE:
// TODO!! Change this ... shouldn't be drawing here ...
		checkcursor();

		drawbg();
		drawscore();
		drawbuttons();

		if( gametype == USEREDIT )
		{
			drawboard( 0 );
		} // end if need to draw board with selected tile
		else
		{
			drawsliderbuttons();
		}

		InvalidateRect( hwndmain, NULL, FALSE );

		break; // end WM_MOUSEMOVE


	} // end switch on Windows Messages for GS_PLAY


	return TRUE;

} // end playmessagehandler






void placeblock( byte blocknumber )
{
	int boardx, boardy, boardspace;


		if( (cursorx < 200) || (cursorx > 600) || (cursory < 100) || (cursory > 500) )
			return; // Off board ...

		boardy = (cursory - 100) / 40;
		boardx = (cursorx - 200) / 40;
		boardspace = (boardy<<3)+(boardy<<1) + boardx;

		board[boardspace] = blocknumber;

		drawboard( 0 );

} // end placeblock






int arrangepuzzlesmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			g_response = TRUE;
			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN



	case WM_LBUTTONDOWN:
		if( (cursorx < 200) || (cursorx > 600) || (cursory < 100) || (cursory > 540) ) break;

		level = (((cursory-100) / 40) * 10) + ((cursorx-200) / 40);
		memcpy( board, puzzleboard[level], 100 );
		g_response = TRUE;
		break;


	case WM_RBUTTONDOWN:
		if( (cursorx < 200) || (cursorx > 600) || (cursory < 100) || (cursory > 540) ) break;

		if( selectedpuzzle == 0xFF )
		{
			selectedpuzzle = (((cursory-100) / 40) * 10) + ((cursorx-200) / 40);
			break;
		}
		else
		{
			int newpuzzle;
			int newpuzzletype;
			byte tempmem[100];


			newpuzzle = (((cursory-100) / 40) * 10) + ((cursorx-200) / 40);

			memcpy( tempmem, puzzleboard[newpuzzle], 100 );
			memcpy( puzzleboard[newpuzzle], puzzleboard[selectedpuzzle], 100 );
			memcpy( puzzleboard[selectedpuzzle], tempmem, 100 );

			newpuzzletype = puzzletype[newpuzzle];
			puzzletype[newpuzzle] = puzzletype[selectedpuzzle];
			puzzletype[selectedpuzzle] = newpuzzletype;

			savepuzzles( lastfilename );

			selectedpuzzle = 0xFF;
			break;
		} // end if puzzle already selected


	} // end switch on Windows Messages for GS_ARRANGEPUZZLES


	return TRUE;

} // end arrangepuzzlesmessagehandler





